/*
 * $QNXLicenseC:
 * Copyright 2009, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

#ifndef NIC_bman_H_INCLUDED
#define NIC_bman_H_INCLUDED

#include "dpaa_priv.h"
#include "Peripherals/bm_ext.h"


typedef struct {
	t_Handle            h_Bm;
    t_Handle            h_BmPortal[DPAA_MAX_SW_PORTAL];
	t_Handle            h_BmPool[DPAA_BMAN_MAX_BPOOL];
	//Pool Information
	t_Handle			h_BufPoolManager;
	uint8_t				numPoolParams;
	bool 				mpool_initialized;
	uint32_t			master_if;
	pthread_mutex_t 	lock[DPAA_MAX_SW_PORTAL];		
} bman_t;

#endif

