/*
 * $QNXLicenseC:
 * Copyright 2009, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */
#ifndef __FMC_API_H
#define __FMC_API_H

#include "dpaa_priv.h"
#include "fman.h"

#define FMC_PCD_MAX_NUM_OF_CC_NODES 128


typedef struct {
    t_Handle            h_Dev;                                      /**< IN:  TODO */
    t_Handle            h_NetEnv;                                   /**< OUT: TODO */
    t_Handle            h_ClsPlanGrp;                               /**< OUT: TODO */
    uint8_t             numOfScmsUsed;                              /**< OUT: TODO */
    t_Handle            h_Schemes[FM_PCD_KG_NUM_OF_SCHEMES];        /**< OUT: TODO */
    t_Handle            h_CcTree;                                   /**< OUT: TODO */
    uint8_t             numOfCcNodes;                               /**< OUT: TODO */
    t_Handle            h_CcNodes[FMC_PCD_MAX_NUM_OF_CC_NODES];     /**< OUT: TODO */
    uint16_t            numOfProfilesUsed;                          /**< OUT: TODO */
    t_Handle            h_Profiles[FM_PCD_PLCR_NUM_ENTRIES];        /**< OUT: TODO */
} t_FmcPortDev;

typedef struct {
    t_Handle            h_Dev;                                      /**< IN: TODO */
    t_Handle            h_PcdDev;                                   /**< IN: TODO */
    uint8_t             numOfScms;                                  /**< IN: TODO */
    bool                validScms[FM_PCD_KG_NUM_OF_SCHEMES];        /**< IN: TODO */
    uint16_t            numOfProfiles;                              /**< IN: TODO */
    bool                validProfiles[FM_PCD_PLCR_NUM_ENTRIES];     /**< IN: TODO */
    t_FmcPortDev        sharedPort;                                 /**< IN: TODO */
    t_FmcPortDev        rxPorts[FM_MAX_NUM_OF_RX_PORTS];            /**< IN: TODO */
    t_FmcPortDev        opPorts[FM_MAX_NUM_OF_OH_PORTS];            /**< IN: TODO */
} t_FmcFmDev;

typedef struct {
    t_FmcFmDev          fms[INTG_MAX_NUM_OF_FM];                    /**< IN: TODO */
} t_Fmc;


t_Error fmc_config(t_Fmc *p_Fmc);


#endif /* __FMC_API_H */
