/*
 * $QNXLicenseC:
 * Copyright 2009, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

#ifndef NIC_qman_H_INCLUDED
#define NIC_qman_H_INCLUDED
#include "dpaa_priv.h"
#include "Peripherals/qm_ext.h"
#include "Peripherals/fm_ext.h"

/********* Qmanager specific Datastructures *****************/
typedef enum {
    FQ_STATE_OOS,
    FQ_STATE_PARKED,
    FQ_STATE_SCHEDULED,
    FQ_STATE_RETIRED,
    FQ_STATE_INVALID
}fq_state_t;

#define QMAN_MAX_ENTRY_PER_EQCR 8
#define QMAN_MAX_ENTRY_PER_DQRR 16
#define QMAN_MAX_ENTRY_PER_MR 8

typedef struct _frame_queue_t {
    uint32_t portal;
    uint32_t chid;
    uint32_t wqid;
    uint32_t fqid;
    uint32_t offset;
    fq_state_t fqstate;
    void* owner;
	void * next;
    fq_handler_funcptr_t fq_handler;
    void *token;
    uint32_t token_size;
	t_Handle h_QmFqr;
}frame_queue_t;

typedef struct {
	frame_queue_t*	fq_list;
    uint32_t fq_count;
	uint32_t master_if;
	t_Handle h_Qm;
	t_Handle h_QmPortal[DPAA_MAX_SW_PORTAL];
	pthread_mutex_t txLock[DPAA_MAX_SW_PORTAL];
	pthread_mutex_t rxLock[DPAA_MAX_SW_PORTAL];
} qman_t;


e_RxStoreResponse qman_fq_cb(t_Handle h_Arg, t_Handle h_QmFqr, t_Handle h_QmPortal, uint32_t fqidOffset, t_DpaaFD *p_Frame);
e_RxStoreResponse DefaultCB(t_Handle h_Arg, t_Handle h_QmFqr, t_Handle h_QmPortal, uint32_t fqidOffset, t_DpaaFD *p_Frame);
#endif

