/*
 * $QNXLicenseC:
 * Copyright 2009, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

#ifndef NIC_dpaa_H_INCLUDED
#define NIC_dpaa_H_INCLUDED

#include "dpaa_priv.h"

//#include "ppc/inline.h"
//#include <ppc/cpu.h>
//#include <ppc/85xxintr.h>
//#include <ppc/83xxintr.h>
//#include <hw/sysinfo.h>

/*Local functions*/
static int dpaa_conf_init_bman_swportal (dpaa_system_t *dpaa, dpaa_cfg_t *cfg);
static int dpaa_conf_init_qman_swportal (dpaa_system_t *dpaa, dpaa_cfg_t *cfg);
static int dpaa_conf_init_fqid (dpaa_system_t *dpaa, dpaa_cfg_t *cfg);
static int dpaa_runtime_queue_enqueue (dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_queue_dequeue (dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_buf_manage (dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_handler(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_clear_irq(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_conf_init_bpool (dpaa_system_t *dpaa, dpaa_cfg_t *cfg);
static int dpaa_conf_config_port (dpaa_system_t *dpaa, dpaa_cfg_t *cfg);


static int dpaa_runtime_enable_port(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_disable_port(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_mac_config(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_get_mac_stats(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_mii_read_write(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_pcd_handle(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
//static int dpaa_runtime_fm_event_irq(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
//static int dpaa_runtime_fm_error_irq(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_dump_regs(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_set_promiscuous(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_add_hashmacaddr(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);
static int dpaa_runtime_del_hashmacaddr(dpaa_system_t *dpaa, dpaa_runtime_t *rtm);


#endif

