/*
 * $QNXLicenseC:
 * Copyright 2010, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

/******************************************************************************

 Copyright  1995-2009 Freescale Semiconductor Inc.

 All Rights Reserved



 **************************************************************************/

#ifndef __PLATFORM_SETTINGS_H
#define __PLATFORM_SETTINGS_H

#include "std_ext.h"


#define CONNECTORS                                                      \
                {       \
                    e_DIAG_MODE_NONE                           \
                    e_DIAG_MODE_NONE                           \
                    e_DIAG_MODE_NONE,                          \
                    e_DIAG_MODE_NONE,                          \
                    e_DIAG_MODE_NONE,                          \
                    e_DIAG_MODE_NONE                          \
                    e_DIAG_MODE_NONE                          \
                    e_DIAG_MODE_NONE                          \
                    e_DIAG_MODE_NONE                          \
                    e_DIAG_MODE_NONE,                          \
                }

#define SET_PLATFORM_SETTINGS(_cache)                                   \
    (t_SysObjectDescriptor *)&((t_SysModuleDescriptor)                  \
    {                                                                   \
        .module = e_SYS_MODULE_PLATFORM,                                \
        .moduleInterface =                                              \
            MODULE_INTERFACE_WITH_PARAM(PLATFORM_Init, PLATFORM_Free),  \
        .p_Settings = &((t_PlatformParam)                               \
        {                                                               \
            .clockInFreqHz = 100000000,                                 \
            .l1CacheMode = _cache,                                      \
            .l2CacheMode = e_CACHE_MODE_DISABLED,                       \
            .l3CacheMode = e_CACHE_MODE_DISABLED,                       \
            .l3SramSize  = 0,                                           \
            .l3StashMode = e_L2_L2CTL_NO_STASH,                         \
            .useDdrBootSettings = FALSE,                                \
            .consoleType = e_PLATFORM_CONSOLE_DUART_1,                  \
            .boardSettings =                                            \
            {                                                           \
                .ethPhySettings =                                       \
                {                                                       \
                    .useAutoNegotiation = TRUE,                         \
                },                                                      \
                .diagModes = CONNECTORS,                                \
            }                                                           \
        })                                                              \
    })


#if (defined(DEBUG_ERRORS) && (DEBUG_ERRORS > 0))
#define PLATFORM_SETTINGS   SET_PLATFORM_SETTINGS(e_CACHE_MODE_DISABLED)
#else
#define PLATFORM_SETTINGS   SET_PLATFORM_SETTINGS(e_CACHE_MODE_DATA_AND_INST)
#endif /* (defined(DEBUG_ERRORS) && ... */


#endif /* __PLATFORM_SETTINGS_H */
