#
# General purpose makefile for building a Neutrino flash device driver
#
ifndef QCONFIG
QCONFIG=qconfig.mk
endif
include $(QCONFIG)

INSTALLDIR=sbin

NAME = devf-$(SECTION)
EXTRA_SILENT_VARIANTS+=$(subst -, ,$(SECTION))

include ../../pinfo.mk

include $(MKFILES_ROOT)/qmacros.mk

-include $(PROJECT_ROOT)/roots.mk
#####AUTO-GENERATED by packaging script... do not checkin#####
   INSTALL_ROOT_nto = $(PROJECT_ROOT)/../../../../install
   USE_INSTALL_ROOT=1
##############################################################

ifndef MTDFLASH_ROOT
MTDFLASH_ROOT=$(PRODUCT_ROOT)/mtd-flash
endif

EXTRA_INCVPATH += $(MTDFLASH_ROOT)/public $(PRODUCT_ROOT)

DEFLIB_VARIANT = $(subst $(space),.,$(strip a $(filter wcc be le v7 spe, $(VARIANTS))))
LIB_VARIANT = $(firstword $(subst ./,,$(dir $(bind))) $(DEFLIB_VARIANT))
EXTRA_LIBVPATH += $(MTDFLASH_ROOT)/$(CPU)/$(LIB_VARIANT)

fs_ver=$(firstword $(F3S_VER) 3)
mtd_ver=$(firstword $(MTD_VER) 2)

LIB_FSFLASH=fs-flash$(fs_ver)

LIBS_COMPRESSION_2=lzo ucl

LIBS_PM=pm ps

LIBS =\
	$(LIB_DEBUG)\
	$(LIB_FSFLASH)\
	mtd-flash\
	$(LIBS_COMPRESSION_$(fs_ver))\
	$(LIB_$(LIB_SUFF)) 

USEFILE = $(MTDFLASH_ROOT)/usagev$(fs_ver).use

CCFLAGS += -DF3S_VER=$(fs_ver) -DMTD_VER=$(mtd_ver)


# If the flash filesystem headers/libraries aren't present on the system, kill
# the compiles.
ifeq ($(call FIND_HDR_DIR,nto,usr/include,fs/f3s_spec.h),)
TARGET_BUILD=@$(ECHO_HOST) Flash filesystem headers/libraries not present on system	
TARGET_INSTALL=
SRCS=
endif

include $(MKFILES_ROOT)/qtargets.mk
