/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include <sys/f3s_mtd.h>

/*
 * Summary
 *
 * MTD Version:     1 only
 * Bus Width:       8-bit and 16-bit
 * Buffered Writes: Yes
 * Note:            Converts f3s_aCFI_v2write() to version 1 API
 *
 * Description
 *
 * Use this for buffered writes.
 */

int32_t f3s_aCFI_write(f3s_dbase_t * dbase,
                       f3s_access_t * access,
                       uint32_t flags,
                       uint32_t offset,
                       int32_t size,
                       uint8_t * buffer)
{
	/* Just a subset of the corresponding v2 function */
	return (f3s_aCFI_v2write(dbase, access, flags, offset, size, buffer));
}


__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/hardware/flash/mtd-flash/amd/aCFI_write.c $ $Rev: 580669 $" );
