/*
 * $QNXLicenseC: 
 * Copyright 2007, 2008, QNX Software Systems.  
 *  
 * Licensed under the Apache License, Version 2.0 (the "License"). You  
 * may not reproduce, modify or distribute this software except in  
 * compliance with the License. You may obtain a copy of the License  
 * at: http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" basis,  
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied. 
 * 
 * This file may contain contributions from others, either as  
 * contributors under the License or as licensors under other terms.   
 * Please review this entire file for other proprietary rights or license  
 * notices, as well as the QNX Development Suite License Guide at  
 * http://licensing.qnx.com/license-guide/ for other information. 
 * $ 
 */

#include "proto.h"

int
mpc8572_set_bus_speed(void *hdl, unsigned int speed, unsigned int *ospeed)
{
    mpc8572_dev_t   *dev = hdl;
	
	if (ospeed)
        *ospeed = dev->scl_freq;
    dev->scl_freq = speed;
    
    /* Set clock and filters */
    if (dev->scl_freq == 100000)
    {
    	out8(dev->unitbase + MPC8572_I2C_MFDR, 0x31);
    	out8(dev->unitbase + MPC8572_I2C_MDFSRR, 0x10);
    }
    else
    {
    	errno = EINVAL;
    	return -1;
    }

    return 0;
}


__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/hardware/i2c/mpc8572/bus_speed.c $ $Rev: 580669 $" );
