/*
 * $QNXLicenseC: 
 * Copyright 2007, 2008, QNX Software Systems.  
 *  
 * Licensed under the Apache License, Version 2.0 (the "License"). You  
 * may not reproduce, modify or distribute this software except in  
 * compliance with the License. You may obtain a copy of the License  
 * at: http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" basis,  
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied. 
 * 
 * This file may contain contributions from others, either as  
 * contributors under the License or as licensors under other terms.   
 * Please review this entire file for other proprietary rights or license  
 * notices, as well as the QNX Development Suite License Guide at  
 * http://licensing.qnx.com/license-guide/ for other information. 
 * $ 
 */

#ifndef __MPC8572_I2C_H_INCLUDED
#define __MPC8572_I2C_H_INCLUDED

#define _SLOGC_I2C	23

#define MPC8572_I2C_BASE    		0xE0003000
#define MPC8572_I2C_SIZE	      	0x20
#define MPC8572_I2C_REGLEN      	0x80

#define MPC8572_I2C_IRQ      	    27

/* I2C Registers */
#define MPC8572_I2C_MADR        	0x00
#define MPC8572_I2C_MFDR        	0x04
#define MPC8572_I2C_MCR         	0x08
#define MPC8572_I2C_MSR         	0x0c
#define MPC8572_I2C_MDR         	0x10
#define MPC8572_I2C_MDFSRR 			0x14

/* Mask definitions for I2C control register */
#define MPC8572_I2C_MCR_MEN      	0x80
#define MPC8572_I2C_MCR_MIEN     	0x40
#define MPC8572_I2C_MCR_MSTA     	0x20
#define MPC8572_I2C_MCR_MTX      	0x10
#define MPC8572_I2C_MCR_TXAK     	0x08
#define MPC8572_I2C_MCR_RSTA     	0x04
#define MPC8572_I2C_MCR_BCST     	0x01

/* Mask definitions for I2C status register */
#define MPC8572_I2C_MSR_MCF      	0x80
#define MPC8572_I2C_MSR_MAAS     	0x40
#define MPC8572_I2C_MSR_MBB      	0x20
#define MPC8572_I2C_MSR_MAL      	0x10
#define MPC8572_I2C_MSR_BCSTM      	0x08
#define MPC8572_I2C_MSR_SRW     	0x04
#define MPC8572_I2C_MSR_MIF      	0x02
#define MPC8572_I2C_MSR_RXAK    	0x01

#endif

__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/hardware/i2c/mpc8572/mpc8572-i2c.h $ $Rev: 580669 $" )
