/*
 * $QNXLicenseC: 
 * Copyright 2007, 2008, QNX Software Systems.  
 *  
 * Licensed under the Apache License, Version 2.0 (the "License"). You  
 * may not reproduce, modify or distribute this software except in  
 * compliance with the License. You may obtain a copy of the License  
 * at: http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" basis,  
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied. 
 * 
 * This file may contain contributions from others, either as  
 * contributors under the License or as licensors under other terms.   
 * Please review this entire file for other proprietary rights or license  
 * notices, as well as the QNX Development Suite License Guide at  
 * http://licensing.qnx.com/license-guide/ for other information. 
 * $ 
 */
 
#include "proto.h"
#include <unistd.h>

int
mpc8572_parseopts(mpc8572_dev_t *dev, int argc, char *argv[])
{
    int c;
    int prev_optind;
    int done = 0;

    dev->i2cbase = MPC8572_I2C_BASE; 		
    dev->reglen = MPC8572_I2C_REGLEN;		
    dev->intr  = MPC8572_I2C_IRQ;			
    dev->scl_freq = 0;
	
	while (!done) {
        prev_optind = optind;
        c = getopt(argc, argv, "i:p:");
        switch (c) {
        case 'i':
            dev->intr = strtoul(optarg, NULL, 0);
            break;
        case 'p':
            dev->i2cbase = strtoull(optarg, NULL, 0);
            break;

        case '?':
            if (optopt == '-') {
                ++optind;
                break;
            }
            return -1;

        case -1:
            if (prev_optind < optind) /* -- */
                return -1;

            if (argv[optind] == NULL) {
                done = 1;
                break;
            } 
            if (*argv[optind] != '-') {
                ++optind;
                break;
            }
            return -1;

        case ':':
        default:
            return -1;
        }
    }
    return 0;
}

__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/hardware/i2c/mpc8572/options.c $ $Rev: 580669 $" );
