/*
 * $QNXLicenseC: 
 * Copyright 2007, 2008, QNX Software Systems.  
 *  
 * Licensed under the Apache License, Version 2.0 (the "License"). You  
 * may not reproduce, modify or distribute this software except in  
 * compliance with the License. You may obtain a copy of the License  
 * at: http://www.apache.org/licenses/LICENSE-2.0  
 *  
 * Unless required by applicable law or agreed to in writing, software  
 * distributed under the License is distributed on an "AS IS" basis,  
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied. 
 * 
 * This file may contain contributions from others, either as  
 * contributors under the License or as licensors under other terms.   
 * Please review this entire file for other proprietary rights or license  
 * notices, as well as the QNX Development Suite License Guide at  
 * http://licensing.qnx.com/license-guide/ for other information. 
 * $ 
 */
 
#include "proto.h"

i2c_status_t
mpc8572_send(void *hdl, void *buf, unsigned int len, unsigned int stop)
{
    mpc8572_dev_t   *dev = hdl;
    i2c_status_t    status = 0;
	
	if (len <= 0)
    {
    	return I2C_STATUS_DONE;
    }
     
    dev->i2c_status = 0; 
    status = mpc8572_sendaddr(dev, dev->slave_addr, MPC8572_I2C_ADDR_WR, dev->restart);  
    	
    if (status)
   		return status;
   	  		
    while (len > 0)
    {
    	status = mpc8572_sendbyte(dev, *(uint8_t *)buf);
       	if (status)
    		return status;
    	++buf;
    	--len;
    }
    	
    if (stop)
    	out8(dev->unitbase + MPC8572_I2C_MCR, MPC8572_I2C_MCR_MEN);
    	
    dev->restart = !stop;
    return I2C_STATUS_DONE;
}





__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/hardware/i2c/mpc8572/send.c $ $Rev: 580669 $" );
