#!/usr/bin/perl

@addrs = (0xeff8,    0xe802,        0xe930,    0xe8f6,      0xef00,      0xe800);
@addrs = (0xeff8,    0xe802,        0xe930,    0xe880,      0xef00,      0xe800);
@names = ("U-Boot",  "LinuxKernel", "Linuxfs", "LinuxFTD",  "Microcode", "RCW");
@vaddrs=();
$bstep = 2;
$base = 0xe800;
$base = 0x0000;
$intro='
P4080DS Multibank memory map

The P4080DS 128Mb flash is divided into 8 16Mb virtual banks.
The Freescale Linux filesystem image is larger than 16Mb and therefore
overlaps 2 of these banks.  Because of the way this and the other Linux
images (kernel and FDT) are laid out, only 2 banks (of 64Mb each) are
usable, banks 0 and 4.  Writing to any other banks will overwrite some of
the Linux images (most likely the filesystem) and make Linux unbootable
from bank 0 or 4.

Note that only even numbered banks (0, 2, 4, 6) are listed below.
Using the odd numbered banks is incompatible with using FM Microcode
images since they end up at the same addresses (in different banks)
and thus overwrite each other.

In short, if you are using Linux images then only use banks 0 and 4.
If you have a linux filesystem that is <12Mb then you can use the even
numbered banks.  If you are not using Linux but are using DPAA FM
microcode images then only use even numbered banks.

';

print $intro;

printf("With bank0 selected on SW7 1-4 (0b0000), here are the addresses of the
images for each of the %d %dMb banks:\n", int(8/$bstep), int(128*$bstep/8));
printf("\n");

printf("%12s", "Bank"); for($bank=0; $bank<8; $bank += $bstep) {
    printf("%10d", $bank);
}
printf("\n");

for($a=0; $a < @addrs; $a++) {
    printf("%-12s", $names[$a]);
    for($bank=0; $bank<8; $bank += $bstep) {
	$vaddr = ($bank<<8) ^ $addrs[$a];
	printf("  %08x", $vaddr<<16);
	push(@vaddrs, $vaddr+0);
    }
    printf("\n");
}
printf("\n");

printf("And here are the addresses and available space for each of the images
with %d banks of %dMb each:\n", int(8/$bstep), int(128*$bstep/8));
printf("\n");

push(@vaddrs, 0xf000);
foreach $vaddr (sort @vaddrs) {
    if (defined($last) && $vaddr != $last) {
	printf("%08x %5dk ", ($last-$base)<<16, ($vaddr-$last)*64);
	for($a=0; $a < @addrs; $a++) {
	    if((($addrs[$a]^$last)&~((8-$bstep)<<8)) == 0) {
		printf(" bank %d %s", (($addrs[$a]^$last)>>8), $names[$a]);
		break;
	    }
	}
	printf("\n");
    }
    $last = $vaddr;
}
