/*
 * $QNXLicenseC:
 * Copyright 2009, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

#include <pic_p40xx.h>

/*
 * initialize space for the vector register offset table. This value represents
 * total number of assigned vectors from init_intrinfo().
 * 
 * vec_config_flags_table_size is only required if patch_data.reg_vectors.config_flags
 * is not NULL. If this is the case it should be exactly the same size as
 * vec_regoffset_table_size
 * 
 * These 2 size values represent the space that must be added to the end of the
 * syspage. They are referenced by the CALLOUT_START macros in the common file
 * callout_interrupt_85xx.s
 * 
 * Necessarily, the size of the vector and config tables are p4080 variant
 * specific hence the location of this file in the boards/startup/<variant>/
 * directory
*/
const long vec_regoffset_table_size = 98 * sizeof(reg_off_t);
const long vec_config_flags_table_size = 98 * sizeof(reg_off_t);

__SRCVERSION( "$URL: $ $Rev: $" );
