/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"


void
as_add_immr(unsigned size, unsigned cpm_size) {
	unsigned	immr;
	paddr_t		cpm_start;

	if(as_find(AS_NULL_OFF, "immr", NULL) == AS_NULL_OFF) {
		immr = as_add(immr_paddr, immr_paddr + size - 1, 
				AS_ATTR_READABLE|AS_ATTR_WRITABLE,
				"immr", 
				as_find(AS_NULL_OFF, "memory", NULL));

		cpm_start = immr_paddr + cpm_offset;
		as_add(cpm_start, cpm_start + cpm_size - 1, 
				AS_ATTR_READABLE|AS_ATTR_WRITABLE,
				"immr_cpm", immr);
	}
}

__SRCVERSION("as_add_immr.c $Rev: 580669 $");
