#
# Copyright 2009, QNX Software Systems. 
# 
# Licensed under the Apache License, Version 2.0 (the "License"). You 
# may not reproduce, modify or distribute this software except in 
# compliance with the License. You may obtain a copy of the License 
# at: http://www.apache.org/licenses/LICENSE-2.0 
# 
# Unless required by applicable law or agreed to in writing, software 
# distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTIES OF ANY KIND, either express or implied.
#
# This file may contain contributions from others, either as 
# contributors under the License or as licensors under other terms.  
# Please review this entire file for other proprietary rights or license 
# notices, as well as the QNX Development Suite License Guide at 
# http://licensing.qnx.com/license-guide/ for other information.
#

#

# 

#
#
# This is a kernel hardware callout.
# This code MUST be position independant.
#

	.include "callout.ah"

#
# unsigned control(	paddr32_t base,
#					unsigned num_lines,
#					int flags,
#					struct cacheattr_entry *cache,
#					volatile struct syspage_entry * )

#
# Perform the cache controller operations indicated by 'flags' 
# (MS_* bits passed to the msync() function).
# Return either number of lines that were handled or 0 to indicate 
# the whole cache.
#
CALLOUT_START	cache_ippc_600, 0, 0
		# Don't try to do all lines (preemption)
		cmplwi	%r4,64
		ble	1f
		# It can be faster to invalidate the whole cache
		cmplwi	%r4,1024
		bge	2f
		li	%r4,64
1:
		lwz	%r9,CA_LINE_SIZE(%r6)
		mtctr	%r4
1:
		icbi	0,%r3			# invalidate one line from ins cache
		add	%r3,%r3,%r9
		bdnz+	1b
		mr	%r3,%r4			# we did all the lines requested mod 64
		isync
		blr
2:
		# Invalidate the whole cache and return 0
		# Cache invalidate bit is cleared automatically in the following clock cycle
		mfspr   %r5,PPC603_SPR_HID0
		li	%r3,0
		ori     %r4,%r5,PPC603_SPR_HID0_ICFI
		isync
		mtspr   PPC603_SPR_HID0,%r4
		sync
		isync
		blr
CALLOUT_END		cache_ippc_600



