#
# Copyright 2007, 2008, QNX Software Systems. 
# 
# Licensed under the Apache License, Version 2.0 (the "License"). You 
# may not reproduce, modify or distribute this software except in 
# compliance with the License. You may obtain a copy of the License 
# at: http://www.apache.org/licenses/LICENSE-2.0 
# 
# Unless required by applicable law or agreed to in writing, software 
# distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTIES OF ANY KIND, either express or implied.
#
# This file may contain contributions from others, either as 
# contributors under the License or as licensors under other terms.  
# Please review this entire file for other proprietary rights or license 
# notices, as well as the QNX Development Suite License Guide at 
# http://licensing.qnx.com/license-guide/ for other information.
#

#

# 

#
#
# An entry point for a hardware kernel callout.
# It may be called by an interrupt handler.
# This code MUST be position independant.
#

	.include "callout.ah"
	.include "asmoff.def"

		
CALLOUT_START	reboot_405, 0, 0
	cmplwi	%r4,0
	beq		1f
	lhz		%r5,SYSPAGE_SYSTEM_PRIVATE(%r3)
	add		%r5,%r5,%r3
	lwz		%r5,SP_PRIVATE_FLAGS(%r5)
	bittst	%r5,%r5,SYSTEM_PRIVATE_FLAG_ABNORMAL_REBOOT
	beq		2f
1:
	loadi	%r3,PPC405_DBCR0_RST_SYSTEM
   	mtspr	PPC405_SPR_DBCR0,%r3
2:
	# disable interrupts
	loadi	%r9,PPC_MSR_EE
	mfmsr	%r8
	andc	%r9,%r8,%r9
	mtmsr	%r9
	b	2b
CALLOUT_END		reboot_405
