#
# Copyright 2007, 2008, QNX Software Systems. 
# 
# Licensed under the Apache License, Version 2.0 (the "License"). You 
# may not reproduce, modify or distribute this software except in 
# compliance with the License. You may obtain a copy of the License 
# at: http://www.apache.org/licenses/LICENSE-2.0 
# 
# Unless required by applicable law or agreed to in writing, software 
# distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTIES OF ANY KIND, either express or implied.
#
# This file may contain contributions from others, either as 
# contributors under the License or as licensors under other terms.  
# Please review this entire file for other proprietary rights or license 
# notices, as well as the QNX Development Suite License Guide at 
# http://licensing.qnx.com/license-guide/ for other information.
#

#

# 

#
#
# An entry point for a hardware kernel callout.
# It may be called by an interrupt handler.
# This code MUST be position independant.
#

	.include "callout.ah"
	.include "asmoff.def"

		
CALLOUT_START	reboot_booke, 0, 0
	# disable interrupts, enable debug exceptions
	loadi	%r3,PPCBKE_DBCR0_IDM
   	mtspr	PPCBKE_SPR_DBCR0,%r3
	loadi	%r9,PPC_MSR_EE|PPC_MSR_CE
	mfmsr	%r8
	andc	%r9,%r8,%r9
	bitset	%r9,%r9,PPC_MSR_DE
	mtmsr	%r9
	
	cmplwi	%r4,0
	beq		1f
	lhz		%r5,SYSPAGE_SYSTEM_PRIVATE(%r3)
	add		%r5,%r5,%r3
	lwz		%r5,SP_PRIVATE_FLAGS(%r5)
	bittst	%r5,%r5,SYSTEM_PRIVATE_FLAG_ABNORMAL_REBOOT
	beq		2f
1:
	# IMPL3 happens to reboot both the IBM and Motorola Book E 
	# implementations (so far). Motorla requires that we have the
	# IDM bit (and DE in the MSR) on. Make sure that the other bits are 
	# off so we don't single step or something silly like that. Sigh. 
	# For an architecture standard, there sure seems to be a lot of 
	# implementation defined aspects :-(.
	loadi	%r3,PPCBKE_DBCR0_RST_IMPL3|PPCBKE_DBCR0_IDM
   	mtspr	PPCBKE_SPR_DBCR0,%r3
2:
	b	2b
CALLOUT_END		reboot_booke
