#
# Copyright 2009 QNX Software Systems. 
# 
# Licensed under the Apache License, Version 2.0 (the "License"). You 
# may not reproduce, modify or distribute this software except in 
# compliance with the License. You may obtain a copy of the License 
# at: http://www.apache.org/licenses/LICENSE-2.0 
# 
# Unless required by applicable law or agreed to in writing, software 
# distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTIES OF ANY KIND, either express or implied.
#
# This file may contain contributions from others, either as 
# contributors under the License or as licensors under other terms.  
# Please review this entire file for other proprietary rights or license 
# notices, as well as the QNX Development Suite License Guide at 
# http://licensing.qnx.com/license-guide/ for other information.
#

#

# 

#
#
# An entry point for a hardware kernel callout.
# It may be called by an interrupt handler.
# This code MUST be position independant.
#

	.include "callout.ah"
		
		
#
# void timer_load(volatile struct syspage_entry *, struct qtime_entry *qtp)
#
CALLOUT_START	timer_load_405, 0, 0 
	lwz	%r0,QT_TIMER_LOAD(%r4)
	mtspr	PIT,%r0
	blr
CALLOUT_END		timer_load_405
		
#
# int timer_reload(volatile struct syspage_entry *, struct qtime_entry *qtp)
#
CALLOUT_START	timer_reload_405, 0,0 
	mfspr 	%r6, TSR
	loadi	%r5, PPC400_TSR_PIS
	and.	%r3, %r6, %r5
	beqlr-
	# clear the interrupt by writing 1 to PIS field
	or 	%r6, %r6, %r5
	mtspr	TSR, %r6
	blr
CALLOUT_END		timer_reload_405
		
#
# unsigned timer_value(volatile struct syspage_entry *, struct qtime_entry *qtp)
#
# Get the current value of the timer (counting up)
#
CALLOUT_START	timer_value_405, 0, 0
	lwz	%r3,QT_TIMER_LOAD(%r4)
	mfspr	%r4,PIT
	sub	%r3,%r3,%r4
	blr
CALLOUT_END		timer_value_405
