#
# Copyright 2007, 2008, QNX Software Systems. 
# 
# Licensed under the Apache License, Version 2.0 (the "License"). You 
# may not reproduce, modify or distribute this software except in 
# compliance with the License. You may obtain a copy of the License 
# at: http://www.apache.org/licenses/LICENSE-2.0 
# 
# Unless required by applicable law or agreed to in writing, software 
# distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTIES OF ANY KIND, either express or implied.
#
# This file may contain contributions from others, either as 
# contributors under the License or as licensors under other terms.  
# Please review this entire file for other proprietary rights or license 
# notices, as well as the QNX Development Suite License Guide at 
# http://licensing.qnx.com/license-guide/ for other information.
#


/*!@(#)callxlc.s	7.1 3/29/97 14:10:21 */
/*
!-------------------------------------------------------------------------------
!
!       OS Open Operating System
!       COPYRIGHT   I B M   CORPORATION 1992
!       LICENSED MATERIAL  -  PROGRAM PROPERTY OF I B M
!       REFER TO COPYRIGHT INSTRUCTIONS: FORM G120-2083
!       US Government Users Restricted Rights - Use, duplication or
!       disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
!
!-------------------------------------------------------------------------------
!-------------------------------------------------------------------------------
!
!  File Name:   callxlc.s
!
!  Function:    The _callxlc function alows for Metaware compiled functions
!               to call to xlc compiled function (as long as floating point.
!               parameters are not used and all the parameters fit in gpr's).
!
!  Author:      Maciej P. Tyrlik
!
!  Notes: 	Input:   r3 -> address of the function descriptor
! 			 r4 -> r10 parameters for xlc function
!
!               Output:  none
!
!  Change Activity-
!
!  Date        Description of Change                                       BY
!  ---------   ---------------------                                       ---
!  01-Sep-92   Created                                                     MPT
!  03-May-95   Added code to mask off external interupts                   mkw
!  18-Aug-97   Port to gcc                                                 -NL 
!
!-------------------------------------------------------------------------------
*/

.set    ..jmpret,0x0
.set    ..jmpstk,0x4
.set    ..jmpregs,0xC
.set    ..jmpcr,0x58

        .text
	.align	2
        .global _callxlc

_callxlc:
        mflr    %r0
        stw     %r0,4(%r1)
        stwu    %r1,-64(%r1)
        stw     %r2,60(%r1)
        lwz     %r0,0x0(%r3)
        mtctr   %r0
        lwz     %r2,0x4(%r3)                    
        ori     %r3,%r4,0x0               /* put parms in proper regs */                
        ori     %r4,%r5,0x0
        ori     %r5,%r6,0x0
        ori     %r6,%r7,0x0
        ori     %r7,%r8,0x0
        ori     %r8,%r9,0x0
        ori     %r9,%r10,0x0
        mfmsr   %r0                      /* get msr */    
        stw     %r0,56(%r1)              /* save the msr */
        addis   %r10,%r0,0xffff          /* turn off ext. int bit */
        ori     %r10,%r10,0x7fff
        and     %r0,%r10,%r0
        mtmsr   %r0                      /* set the msr */  
        bctrl                            /* call the xcoff function */
        lwz     %r0,68(%r1)
        mtlr    %r0
        lwz     %r2,60(%r1)
        lwz     %r0,56(%r1)
        mtmsr   %r0                     /* restore the msr    */
        addi    %r1,%r1,64
        blr

	.type _callxlc,@function
	.size _callxlc,.-_callxlc
