/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include "cpc700_intrs.h"

paddr_t				cpc700_intr_base;

void
config_cpc700_intrs(paddr_t paddr, unsigned pol, unsigned trig) {

	cpc700_intr_base = paddr;

	chip_access(paddr, 0, 0, 0x24);
	chip_write32(CPC700_UIC_SR_OFF,0xFFFFFFFF);     /* clear all ints */
	chip_write32(CPC700_UIC_ER_OFF,0x00000000);     /* disable all ints */
	chip_write32(CPC700_UIC_CR_OFF,0xFFFFFFFF);     /* set all ints to be critical */
	chip_write32(CPC700_UIC_PR_OFF,pol); 		    /* set int polarities */
	chip_write32(CPC700_UIC_TR_OFF,trig); 		    /* set int trigger levels */
	chip_write32(CPC700_UIC_VCR_OFF,0x00000001);    /* set vect base=0,INT0 highest priority*/
	chip_write32(CPC700_UIC_SR_OFF,0xFFFFFFFF);     /* clear all ints */
	chip_done();
}

__SRCVERSION("cpc700_intrs.c $Rev: 580669 $");
