/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */






#define CPC700_UIC_BASE		0xff500880

#define CPC700_UIC_SR_OFF	0x00
#define CPC700_UIC_SRS_OFF	0x04
#define CPC700_UIC_ER_OFF	0x08
#define CPC700_UIC_CR_OFF	0x0c
#define CPC700_UIC_PR_OFF	0x10
#define CPC700_UIC_TR_OFF	0x14
#define CPC700_UIC_MSR_OFF	0x18
#define CPC700_UIC_VR_OFF	0x1c
#define CPC700_UIC_VCR_OFF	0x20

extern struct callout_rtn	interrupt_mask_cpc700;
extern struct callout_rtn	interrupt_unmask_cpc700;
extern struct callout_rtn	interrupt_id_cpc700;
extern struct callout_rtn	interrupt_eoi_cpc700;

extern paddr_t				cpc700_intr_base;

void config_cpc700_intrs(paddr_t paddr, unsigned pol, unsigned trig);

#define CPC700_INTRS(base)										\
	{ 	base, 32, _NTO_INTR_SPARE, PPC_EXC_EXTERNAL_INTR, 0, 0, \
		{0, 0, &interrupt_id_cpc700},							\
		{INTR_GENFLAG_LOAD_INTRMASK, 0, &interrupt_eoi_cpc700},	\
		&interrupt_mask_cpc700, &interrupt_unmask_cpc700, 0,	\
		&cpc700_intr_base,										\
	},

/* __SRCVERSION("cpc700_intrs.h $Rev: 580669 $"); */
