/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */






/* Registers are offsets from the mpic base address */
#define CPC925_CFG_REG			0x1020
#define CPC925_IPI_REG_START	0x10a0
#define CPC925_IPI_VEC_OFF		0x00
#define CPC925_IPI_REG_SPACING	0x10
#define CPC925_IPI_NUM			2
#define CPC925_INT_REG_START	0x10000
#define CPC925_INT_VEC_OFF		0x00
#define CPC925_INT_DST_OFF		0x10
#define CPC925_INT_REG_SPACING	0x20
#define CPC925_INT_NUM			124
#define CPC925_SPUR_VECT		0x10e0
#define CPC925_TASKPRIO_0		0x20080
#define CPC925_TASKPRIO_1		0x21080

extern struct callout_rtn	interrupt_id_cpc925;
extern struct callout_rtn	interrupt_eoi_cpc925;
extern struct callout_rtn	interrupt_mask_cpc925;
extern struct callout_rtn	interrupt_unmask_cpc925;
extern struct callout_rtn	interrupt_config_cpc925;

extern struct callout_rtn 	sendipi_cpc925;

extern paddr_t	cpc925_mpic_base;

extern void config_cpc925(paddr_t);

#define CPC925_INTRS(first_intr)	\
	{ 	first_intr, CPC925_INT_NUM+CPC925_IPI_NUM, _NTO_INTR_SPARE, PPC_EXC_EXTERNAL_INTR, 0, 0,\
		{INTR_GENFLAG_LOAD_CPUNUM, 0, &interrupt_id_cpc925},		\
		{INTR_GENFLAG_LOAD_CPUNUM, 0, &interrupt_eoi_cpc925},		\
		&interrupt_mask_cpc925, &interrupt_unmask_cpc925,			\
		&interrupt_config_cpc925,									\
		&cpc925_mpic_base											\
	},																

/* __SRCVERSION("cpc925.h $Rev: 580669 $"); */
