/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */







//
// Initialize interrupt controller hardware & intrinfo structure in the
// system page.
// This code is hardware dependant and may have to be changed
// changed by end users.
//



/* Registers are offsets from the epic base address */
#define EPIC_GLOBAL_CFG_REG		0x1020
#define EPIC_INT_CFG			0x1030
#define EPIC_SPURIOUS_REG		0x10e0
#define EPIC_INTREG_BASE		0x10200
#define EPIC_DUART_INTREG_BASE	0x11120
#define EPIC_TIMER_INTREG_BASE	0x01120
#define EPIC_I2CDMA_INTREG_BASE 0x11020
#define EPIC_MSG_INTREG_BASE 	0x110c0
#define EPIC_INT_REG_OFF		0x20
#define EPIC_TIMER_INT_REG_OFF	0x40
#define EPIC_INT_DST_OFF		0x10
#define EPIC_TASKPRIO_0		    0x20080


#define	EPIC_NUM_INTR	26
 

extern struct callout_rtn   interrupt_mask_epic;
extern struct callout_rtn   interrupt_unmask_epic;
extern struct callout_rtn   interrupt_id_epic;
extern struct callout_rtn   interrupt_eoi_epic;

extern paddr_t	epic_base;

extern void config_epic(paddr_t);

#define EPIC_INTRS(first_intr) \
	{ 	first_intr,EPIC_NUM_INTR, _NTO_INTR_SPARE, PPC_EXC_EXTERNAL_INTR, 0, 0,\
		{0, 0, &interrupt_id_epic},                                                  \
		{INTR_GENFLAG_LOAD_INTRMASK, 0, &interrupt_eoi_epic},                        \
		&interrupt_mask_epic, &interrupt_unmask_epic, 0, &epic_base                  \
	},                                                                               


/* __SRCVERSION("epic.h $Rev: 580669 $"); */
