/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





/*
 * harrier_system_clock()
 * Find the system clock speed on a system with a harrier chipset.
 *
 */

#include "startup.h"

unsigned
harrier_system_clock(paddr_t xcsr_base) {
	unsigned 	sys_clk;
	uintptr_t	harrier;

	harrier = startup_io_map(0x20, xcsr_base);
	sys_clk = in32(harrier + 0x14);
	startup_io_unmap(harrier);
	return((sys_clk >> 24) * 1000000);
}

__SRCVERSION("harrier_system_clock.c $Rev: 580669 $");
