/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include <ppc/800cpu.h>

/*
 * Clock setup for PPC 800 onchip RTC.
*/

unsigned long
rtc_time_rtc8xx() {
	volatile struct {
		uint16_t	rtcsc;
		uint16_t	spare;
		uint32_t	rtc;
	}	*rtc;

	rtc = (void *)((get_spr(PPC800_SPR_IMMR)&0xffff0000) + PPC800_IMMR_RTCSC);

	//Tell Neutrino what kind of chip for 'rtc' utility
	if(!(rtc->rtcsc & PPC800_RTCSC_RTE)) {
		hwi_add_device(HWI_ITEM_BUS_UNKNOWN, HWI_ITEM_DEVCLASS_RTC, "NONE", 0);
		return 0;
	}

	hwi_add_device(HWI_ITEM_BUS_UNKNOWN, HWI_ITEM_DEVCLASS_RTC, "rtc8xx", 0);
	return rtc->rtc;
}

__SRCVERSION("hw_rtc_rtc8xx.c $Rev: 580669 $");
