/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */






#define MV64360_BASE_DEFAULT		0x1400000

/* Registers are offsets from the base address */
#define MV64360_CPUMASK0_LO			0x014
#define MV64360_CPUMASK0_HI			0x01c

#define MV64360_CPUMASK1_LO			0x034
#define MV64360_CPUMASK1_HI			0x03c

#define MV64360_CPU_SELECTCAUSE		0x024

#define MV64360_GPP_IOCTL			0xf100
#define MV64360_GPP_LEVEL			0xf110
#define MV64360_GPP_CAUSE			0xf108
#define MV64360_GPP_MASK			0xf10c

#define MV64360_CPU0_DOORBELL_CLEAR	0x21C
#define MV64360_CPU1_DOORBELL_CLEAR	0x22C
#define MV64360_CPU0_DOORBELL_MASK	0x234
#define MV64360_CPU1_DOORBELL_MASK	0x23C

extern struct callout_rtn	interrupt_id_mv64360;
extern struct callout_rtn	interrupt_eoi_mv64360;
extern struct callout_rtn	interrupt_mask_mv64360;
extern struct callout_rtn	interrupt_unmask_mv64360;
extern struct callout_rtn	interrupt_config_mv64360;

extern struct callout_rtn 	sendipi_mv64360;

extern struct callout_rtn 	reboot_mv64360;

extern paddr_t	mv64360_base;

extern void mv64360_set_base_paddr(paddr_t);
extern void mv64360_config(void);
extern void mv64360_init_raminfo(void);

#define MV64360_INTRS(first_intr)	\
	{ 	first_intr, 64+32, _NTO_INTR_SPARE, PPC_EXC_EXTERNAL_INTR, 0, 0,\
		{INTR_GENFLAG_LOAD_CPUNUM, 0, &interrupt_id_mv64360},	\
		{INTR_GENFLAG_LOAD_INTRMASK|INTR_GENFLAG_LOAD_CPUNUM, 0, &interrupt_eoi_mv64360},\
		&interrupt_mask_mv64360, &interrupt_unmask_mv64360,		\
		&interrupt_config_mv64360,								\
		&mv64360_base											\
	},														

/* __SRCVERSION("mv64360.h $Rev: 580669 $"); */
