/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





/*
 * init_raminfo.c
 *	Tell syspage about our RAM configuration
 */
#include "startup.h"
#include "usr_func.h"

void
openbios_init_raminfo(void) {
	struct board_cfg_data *board_cfg_ptr;

	//Get the amount of memory from the ROM Monitor          -NL
	
	board_cfg_ptr = (struct board_cfg_data *)_callxlc(BOARD_CFG_FP);

	#define LOW_VERSION	"1.1"

	if(strcmp((char *)board_cfg_ptr->usr_config_ver, LOW_VERSION) < 0) {
		crash("init_raminfo: board version mismatch\n"
				"got %s, expecting " LOW_VERSION " or later\n",
			board_cfg_ptr->usr_config_ver);
	}

	add_ram(0, board_cfg_ptr->mem_size);
}

__SRCVERSION("openbios_init_raminfo.c $Rev: 580669 $");
