/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





//NYI: MSI interrupts

/* Registers are offsets from the mpic base address */
#define PA6T_1682_SPUR_VECT			0x10e0
#define PA6T_1682_TASKPRIO_0		0x20080
#define PA6T_1682_TASKPRIO_1		0x21080
#define PA6T_1682_INT_VEC_OFF		0x00
#define PA6T_1682_INT_DST_OFF		0x10
#define PA6T_1682_INT_NUM			512
#define PA6T_1682_INT_REG_START		0x10000
#define PA6T_1682_INT_REG_SPACING	0x20
#define PA6T_1682_MSI_NUM			512
#define PA6T_1682_MSI_REG_START		0x14000
#define PA6T_1682_MSI_REG_SPACING	0x20
#define PA6T_1682_IPI_NUM			4
#define PA6T_1682_IPI_REG_START		0x010a0
#define PA6T_1682_IPI_REG_SPACING	0x10
#define PA6T_1682_TIMER_NUM			8
#define PA6T_1682_TIMER_REG_START	0x01120
#define PA6T_1682_TIMER_REG_SPACING	0x40

extern struct callout_rtn	interrupt_id_pa6t_1682;
extern struct callout_rtn	interrupt_eoi_pa6t_1682;
extern struct callout_rtn	interrupt_mask_pa6t_1682;
extern struct callout_rtn	interrupt_unmask_pa6t_1682;
extern struct callout_rtn	interrupt_config_pa6t_1682;

extern struct callout_rtn 	sendipi_pa6t_1682;

extern paddr_t	pa6t_1682_mpic_base;

extern void config_pa6t_1682(paddr_t);

//NYI: IPI and timers
#define PA6T_1682_INTRS(first_intr)	\
	{ 	first_intr, PA6T_1682_INT_NUM+PA6T_1682_MSI_NUM+PA6T_1682_IPI_NUM+PA6T_1682_TIMER_NUM, _NTO_INTR_SPARE, PPC_EXC_EXTERNAL_INTR, 0, 0,\
		{0, 0, &interrupt_id_pa6t_1682},						\
		{0, 0, &interrupt_eoi_pa6t_1682},						\
		&interrupt_mask_pa6t_1682, &interrupt_unmask_pa6t_1682,	\
		&interrupt_config_pa6t_1682,							\
		&pa6t_1682_mpic_base									\
	},																

/* __SRCVERSION("pa6t_1682.h $Rev: 580669 $"); */
