/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */







#include "startup.h"
#include <ppc/85xxcpu.h>


#define	PPC85xx_IMMR(reg,size)	(*(volatile uint##size##_t *)(pv_cpm_base_addr+PPC8260_IMMR_OFF_##reg))

void 
ppc85xx_config_pic_cpm(void) {
	uintptr_t	pv_cpm_base_addr;

	/* Mask off all the CPM interrupt sources */
	/* CPM address has offset included to account for difference between 
	8260 IMMR and 8560 IMMR. */

	pv_cpm_base_addr = startup_io_map(0x14000, immr_paddr + cpm_offset);
	PPC85xx_IMMR(SIMR_H,32) = 0;
	PPC85xx_IMMR(SIMR_L,32) = 0;
	startup_io_unmap(pv_cpm_base_addr);
}

__SRCVERSION("pic_85xxcpm.c $Rev: 580669 $");
