/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */

#ifndef __PIC_P40XX_H_INCLUDED
#define __PIC_P40XX_H_INCLUDED

#include <stdint.h>
#include <ppc/p4080cpu.h>
#include <pic_85xx_common.h>

/*
 * =============================================================================
 *                                M A C R O S
 * =============================================================================
*/
/*
 * PIC_IN
 * PIC_OUT
 * 
 * convenience macros for accessing the PIC vector registers
*/
#define PIC_IN(base, r)			in32(base+ (PPCP4080_CCSR_OFF_##r))
#define PIC_OUT(base, r, v)		out32(base+ (PPCP4080_CCSR_OFF_##r),v)

/*
 * VP_DEFAULT
 * 
 * by default, all vector registers will be assigned an priority of '1' and be
 * masked
*/
#define VP_DEFAULT				PPCP4080_xIVPR_MSK
#define DEFAULT_INT_TARGET		0x00000000

/*
 * =============================================================================
 *                   F O R W A R D   D E C L A R A T I O N S
 * =============================================================================
*/

extern uint32_t p4080_config_pic(uint32_t os_vector_base, uint32_t pic_vector_base, vector_tbl_t *reg_vectors);

#endif	/* __PIC_P40XX_H_INCLUDED */


__SRCVERSION("pic_p40xx.h $Rev: $");
