/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





/*
 * init_raminfo.c
 *	Tell syspage about our RAM configuration
 */
#include "startup.h"
#include <ppc/400sdram.h>

static void
one_bank(unsigned bxcr) {
	unsigned	v;

	v = ppc400_get_sdram0(bxcr);
	if(v & PPC400_SDRAM0_BxCR_SDBE) {
		add_ram(v & PPC400_SDRAM0_BxCR_SDBA_MASK,
		  MEG(4)<<((v&PPC400_SDRAM0_BxCR_SDSZ_MASK)>>PPC400_SDRAM0_BxCR_SDSZ_SHIFT));
	}
}

void
ppc400_sdram0_init_raminfo() {
	one_bank(PPC400_SDRAM0_B0CR);
	one_bank(PPC400_SDRAM0_B1CR);
	one_bank(PPC400_SDRAM0_B2CR);
	one_bank(PPC400_SDRAM0_B3CR);
}

__SRCVERSION("ppc400_sdram0_init_raminfo.c $Rev: 580669 $");
