/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





/*
 * ppc405_init_raminfo.c
 * Tell syspage about our RAM configuration
 */
#include "startup.h"

void ppc405_init_raminfo() 
{
	int i;
	unsigned long dcr;

	/* detect 405 memory */
	for (i = 0; i < 16; i += 4) {
		set_dcr(PPC405_DCR_SDRAM0_CFGADDR, (i + PPC405_SDRAM0_B0CR));
		dcr = get_dcr(PPC405_DCR_SDRAM0_CFGDATA);

		/*
		 * bits 19, 18, and 17 represent the size of the bank, where
		 * 000 = 4M, 001 = 8M, etc., up to 110 = 256M. 
		 */
		if (dcr & 1) 	/* bank is enabled */
			add_ram(dcr & 0xff800000, MEG(4 << ((dcr & 0x000e0000) >> 17)));
	}
}

__SRCVERSION("ppc405_init_raminfo.c $Rev: 580669 $");
