#
# Copyright 2007, 2008, QNX Software Systems. 
# 
# Licensed under the Apache License, Version 2.0 (the "License"). You 
# may not reproduce, modify or distribute this software except in 
# compliance with the License. You may obtain a copy of the License 
# at: http://www.apache.org/licenses/LICENSE-2.0 
# 
# Unless required by applicable law or agreed to in writing, software 
# distributed under the License is distributed on an "AS IS" basis, 
# WITHOUT WARRANTIES OF ANY KIND, either express or implied.
#
# This file may contain contributions from others, either as 
# contributors under the License or as licensors under other terms.  
# Please review this entire file for other proprietary rights or license 
# notices, as well as the QNX Development Suite License Guide at 
# http://licensing.qnx.com/license-guide/ for other information.
#

	.include "ppc/util.ah"

#
# Try to set the PIR register on a 600 class chip, ignoring any
# exception (700 series didn't implement the register).
#

fault_handler:
	mfsrr0		%r4
	addi		%r4,%r4,4
	mtsrr0		%r4
	rfi
fault_handler_end:
	
.set	PROGRAM_EXC,0x700

routine_start ppc600_set_pir, 1

	# install program fault handler
	
	lis		%r12,fault_handler@ha
	la		%r12,fault_handler@l(%r12)
	lswi	%r4,%r12,fault_handler_end - fault_handler
	li		%r12,PROGRAM_EXC
	stswi	%r4,%r12,fault_handler_end - fault_handler
	dcbst	0,%r12
	sync
	icbi	0,%r12
	isync
	
	mtspr	1023,%r3
	
	blr
routine_end ppc600_set_pir
