/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */







/*
 * ppc83xx_init_raminfo.c
 * Tell syspage about our RAM configuration
 */
#include "startup.h"


static void one_bank(unsigned csbnds)
{
	uint32_t	start, size;

	start = (csbnds & PPC83xx_CSx_BNDS_SA_MASK) << PPC83xx_CSx_BNDS_SA_SHIFT;
	size  = (((csbnds & PPC83xx_CSx_BNDS_EA_MASK) + 1) << PPC83xx_CSx_BNDS_EA_SHIFT) - start;
	add_ram(start, size);
	ppc600_update_one_to_one_limit(start+size);
}

void ppc83xx_init_raminfo(void)
{
	uintptr_t	pv_immr_base_addr = startup_io_map(0x3000, immr_paddr);

	if (PPC83xx_IMMR(pv_immr_base_addr, CS0_CONFIG, 32) & PPC83xx_CSx_CONFIG_CSEN)
		one_bank(PPC83xx_IMMR(pv_immr_base_addr, CS0_BNDS, 32));

	if (PPC83xx_IMMR(pv_immr_base_addr, CS1_CONFIG, 32) & PPC83xx_CSx_CONFIG_CSEN)
		one_bank(PPC83xx_IMMR(pv_immr_base_addr, CS1_BNDS, 32));

	if (PPC83xx_IMMR(pv_immr_base_addr, CS2_CONFIG, 32) & PPC83xx_CSx_CONFIG_CSEN)
		one_bank(PPC83xx_IMMR(pv_immr_base_addr, CS2_BNDS, 32));

	if (PPC83xx_IMMR(pv_immr_base_addr, CS3_CONFIG, 32) & PPC83xx_CSx_CONFIG_CSEN)
		one_bank(PPC83xx_IMMR(pv_immr_base_addr, CS3_BNDS, 32));

	startup_io_unmap(pv_immr_base_addr);
}

__SRCVERSION("ppc83xx_init_raminfo.c $Rev: 580669 $");
