/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */






#include "startup.h"


unsigned ppc83xx_set_clock_freqs(unsigned inputclk)
{
	unsigned	spmf, ckdiv, csb_clk, rcwlr;
	uintptr_t	pv_immr_base_addr = startup_io_map(0x1000, immr_paddr);

	ckdiv = (PPC83xx_IMMR(pv_immr_base_addr, SPMR, 32) & PPC83xx_SPMR_CKID) >> PPC83xx_SPMR_CKID_SHIFT;

	if ((PPC83xx_IMMR(pv_immr_base_addr, RCWHR, 32) & PPC83xx_RCWHR_PCIHOST) && ckdiv)
		inputclk >>= 1;

	rcwlr = PPC83xx_IMMR(pv_immr_base_addr, RCWLR, 32);

	spmf = (rcwlr & PPC83xx_RCWLR_SPMF_MASK) >> PPC83xx_RCWLR_SPMF_SHIFT;

	csb_clk = (inputclk * spmf * (1 + ckdiv));

	if (cycles_freq == 0)
		cycles_freq = timer_freq = csb_clk >> 2;

	if (cpu_freq == 0) {
		if (((rcwlr >> PPC83xx_RCWLR_COREPLL_SHIFT) & 0x1E) == 0)
			cpu_freq = csb_clk;		/* Core PLL bypass */
		else
			cpu_freq = (csb_clk * ((rcwlr >> PPC83xx_RCWLR_COREPLL_SHIFT) & 0x1F)) >> 1;
	}

	startup_io_unmap(pv_immr_base_addr);

	return csb_clk;
}

__SRCVERSION("ppc83xx_set_clock_freqs.c $Rev: 580669 $");
