/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include <ppc/85xxcpu.h>

// Init the L2 cache on PPC85xx family chips. 

#define PPC85XX_L2CTL  (immr_paddr + 0x20000)

void 
ppc85xx_init_l2_cache(void) {
	uint32_t l2c_vloc, l2c;
	  
	l2c_vloc = (uint32_t)startup_io_map(4, PPC85XX_L2CTL);

	ppc_isync();
	l2c = in32(l2c_vloc);
	out32(l2c_vloc, l2c | 0x08000000);
	in32(l2c_vloc);
	ppc_sync();
	
	ppc_isync();
	l2c = in32(l2c_vloc);
	out32(l2c_vloc, l2c | 0x40000000);
	while(in32(l2c_vloc) & 0x40000000);
	ppc_sync();

	ppc_isync();
	l2c = in32(l2c_vloc);
	out32(l2c_vloc, l2c | 0x80000000);
	in32(l2c_vloc);
	ppc_sync();
	
	startup_io_unmap(l2c_vloc);
}

__SRCVERSION("ppc85xx_init_l2_cache.c $Rev: 580669 $");
