/*
 * $QNXLicenseC:
 * Copyright 2009, QNX Software Systems.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"). You
 * may not reproduce, modify or distribute this software except in
 * compliance with the License. You may obtain a copy of the License
 * at: http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as
 * contributors under the License or as licensors under other terms.
 * Please review this entire file for other proprietary rights or license
 * notices, as well as the QNX Development Suite License Guide at
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */


#include "startup.h"
#include <ppc/e500cpu.h>

void 
ppcbke_tlb_write_e500mc(int tlbnum, int idx, const ppcbke_tlb_t *tlb) {
	if(!(get_msr() & PPC_MSR_GS)) {
		// If we're running on the bare metal (not under control of a 
		// hypervisor) we have to make sure to zero out the hypervisor
		// state of the TLB entries (TGS, VF, and TLPID fields) in the
		// MAS8 register. 
		set_spr(PPCBKEM_SPR_MAS8, 0);
	}
	ppcbke_tlb_write_e500v2(tlbnum, idx, tlb);
}

__SRCVERSION("ppcbke_tlb_e500mc.c $Rev: 580669 $");
