/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"). You
 * may not reproduce, modify or distribute this software except in
 * compliance with the License. You may obtain a copy of the License
 * at: http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as
 * contributors under the License or as licensors under other terms.
 * Please review this entire file for other proprietary rights or license
 * notices, as well as the QNX Development Suite License Guide at
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

int
ppcbke_tlb_info_motorola(enum mmu_info info, unsigned tlb) {
	unsigned	mmucfg = get_spr(PPCBKEM_SPR_MMUCFG);
	unsigned	ntlbs;
	unsigned	tlbinfo;
	unsigned	minsize;
	unsigned	maxsize;
	unsigned	pgsizes;

	ntlbs = ((mmucfg & PPCBKEM_MMUCFG_NTLBS_MASK) >> PPCBKEM_MMUCFG_NTLBS_SHIFT) + 1;
	if(tlb < ntlbs) {
		switch(tlb) {
		case 0:	tlbinfo = get_spr(PPCBKEM_SPR_TLB0CFG); break;
		case 1:	tlbinfo = get_spr(PPCBKEM_SPR_TLB1CFG); break;
		case 2:	tlbinfo = get_spr(PPCBKEM_SPR_TLB2CFG); break;
		case 3:	tlbinfo = get_spr(PPCBKEM_SPR_TLB3CFG); break;
		default: tlbinfo = 0; break;
		}
		switch(info) {
		case MI_PAGESIZES:
			minsize = (tlbinfo & PPCBKEM_TLBCFG_MINSIZE_MASK) >> PPCBKEM_TLBCFG_MINSIZE_SHIFT;
			maxsize = (tlbinfo & PPCBKEM_TLBCFG_MAXSIZE_MASK) >> PPCBKEM_TLBCFG_MAXSIZE_SHIFT;
			pgsizes = (1 << minsize) | (1 << maxsize);
			if(tlbinfo & PPCBKEM_TLBCFG_AVAIL) {
				while(minsize < maxsize) {
					pgsizes |= (1 << minsize);
					++minsize;
				}
			}
			return pgsizes;
		case MI_NUM_ENTRIES:
			return (tlbinfo & PPCBKEM_TLBCFG_NENTRY_MASK) >> PPCBKEM_TLBCFG_NENTRY_SHIFT;
		}
	}
	return -1;
}

__SRCVERSION("ppcbke_tlb_info_motorola.c $Rev: 580669 $");
