/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include "hidpll.h"


// ppcv_cpuconfig2_750fx & ppcv_setup_750fx routines just needed to
// work around a chip bug. Can get rid of them later....

static void
ppcv_cpuconfig2_750fx(int cpu) {
	unsigned	hid;

	ppcv_cpuconfig2_700(cpu);
	hid_pll_bits = hid_pll_bits_750fx;

	// turn off DPM for DD2.0 750FX errata; OK on 2.1 and above
	hid = get_spr(PPC603_SPR_HID0);
	hid &= ~(PPC700_SPR_HID0_DPM | PPC700_SPR_HID0_EICE);
	set_spr(PPC603_SPR_HID0, hid);
}

static void
ppcv_setup_750fx(void) {
	ppcv_setup_700();

	ppcv_config.cpuconfig2 = &ppcv_cpuconfig2_750fx;

}

const struct ppcv_chip ppcv_chip_750fx = {
	PPC_750FX,
	32, 5, 1024, 1024,
	PPC_CPU_EAR | PPC_CPU_SW_TLBSYNC | PPC_CPU_HW_HT | PPC_CPU_HW_POW | PPC_CPU_DCBZ_NONCOHERENT | PPC_CPU_EXTRA_BAT,
	0x00082200,
	"750fx",
	&ppcv_setup_750fx
};

__SRCVERSION("ppcv_chip_750fx.c $Rev: 580669 $");
