/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"). You
 * may not reproduce, modify or distribute this software except in
 * compliance with the License. You may obtain a copy of the License
 * at: http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as
 * contributors under the License or as licensors under other terms.
 * Please review this entire file for other proprietary rights or license
 * notices, as well as the QNX Development Suite License Guide at
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"


const struct ppcv_chip ppcv_chip_e500mc = {
	PPC_E500MC,
	36, 													/* paddr bits */
	6,														/* cache lsize, 64 bytes per cache line -> 2^6 */
	512, 512,												/* icache & dcache lines -- 32KB caches */
	PPC_CPU_NO_MFTB | PPC_CPU_XASPACE | CPU_FLAG_FPU,		/* flags -- has a real FPU, support xaspace
															       message pass */
	0,														/* pretend_cpu */
	"E500mc Core",
	&ppcv_setup_p40xx	/* This works for now since the only e500mc we support is the p40xx. In the future
						   may need to use SPR_SVR to detect e500mc variants in ppcv_setup_e500mc */
};

__SRCVERSION("ppcv_chip_e500mc.c $Rev: 169767 $");
