/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

void
ppcv_cpuconfig2_405(int cpu) {
	// Implement workarounds for various bugs
	switch(get_pvr()) {
	case 0x40110040: //rev B
	case 0x40110082: //rev C
	case 0x40310083: //vesta, based on rev b of 405 core

/* Workaround for PPC405 bug #38 (fixed in rev D) */
		set_spr(PPC405_SPR_CCR0, get_spr(PPC405_SPR_CCR0) | 0x40000000);
/* end workaround */
	    //fall through
	case 0x401100c4: //rev D
/* Workaround for PPC405 bug #58 (fixed in rev E) */
		set_dcr(PPC405_DCR_OCM0_DSCNTL, get_dcr(PPC405_DCR_OCM0_DSCNTL) & ~0xc0000000);
/* end workaround */
	}
}

__SRCVERSION("ppcv_cpuconfig_405.c $Rev: 580669 $");
