/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include <ppc/440cpu.h>

void
ppcv_cpuconfig1_440(int cpu) {

	/* Disable machine check and interrupt */
	set_msr(get_msr() & ~(PPC_MSR_ME | PPC_MSR_EE | PPC_MSR_CE));

	ppcv_cpuconfig1_booke(cpu);
}

void
ppcv_cpuconfig2_440(int cpu) {
	ppcv_cpuconfig2_booke(cpu);

	/*
	 * Clear PPC440_MMUCR_DULXE, PPC440_MMUCR_IULXE.
	 */
	set_spr(PPC440_SPR_MMUCR, get_spr(PPC440_SPR_MMUCR) & ~(PPC440_MMUCR_DULXE | PPC440_MMUCR_IULXE));

	/* Clear machine check error status */
	set_spr(PPC440_SPR_MCSR, get_spr(PPC440_SPR_MCSR));
}

__SRCVERSION("ppcv_cpuconfig_440.c $Rev: 580669 $");
