/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include <ppc/440cpu.h>

void
ppcv_cpuconfig2_440ep(int cpu) {
	struct cpuinfo_entry	*cpuinfo = lsp.cpuinfo.p;

	ppcv_cpuconfig2_440(cpu);

	if (cpuinfo->flags & CPU_FLAG_FPU) {
		/* FPU enabled, enable APU instruction broadcast */
		set_spr(PPC440_SPR_CCR0, get_spr(PPC440_SPR_CCR0) & ~PPC440_CCR0_DAPUIB);
	} else {
		/* FPU disabled, disable APU instruction broadcast */
		set_spr(PPC440_SPR_CCR0, get_spr(PPC440_SPR_CCR0) | PPC440_CCR0_DAPUIB);
	}
}

__SRCVERSION("ppcv_cpuconfig_440ep.c $Rev: 580669 $");
