/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

void
ppcv_cpuconfig1_800(int cpu) {
	set_msr(get_msr() & ~PPC_MSR_IP);

	// change IMMR to low address (below 1G) to map it into
	// kernel virtual memory space
	set_spr(PPC800_SPR_IMMR, 0x30000000);

	/* turn off single step 'cause' in the DER which makes the decrementer/TB stop during debug */
	set_spr(PPC800_SPR_DER,(get_spr(PPC800_SPR_DER) & ~(_ONEBIT32B(14))));
}

__SRCVERSION("ppcv_cpuconfig_800.c $Rev: 580669 $");
