/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */



#include "startup.h"
#include <ppc/970cpu.h>

	
void
ppcv_cpuconfig1_900(int cpu) {
	if(shdr->flags1 & STARTUP_HDR_FLAGS1_VIRTUAL) {
		ppcv_mmuconfig1_900(cpu);
	}
}

void
ppcv_cpuconfig2_900(int cpu) {
	if(shdr->flags1 & STARTUP_HDR_FLAGS1_VIRTUAL) {
		ppcv_mmuconfig2_900(cpu);
	}
	// Make sure we don't get any interrupts from the decrementer until
	// we're ready for them.
	set_spr(PPC_SPR_DEC, 0x7fffffff); 
}

__SRCVERSION("ppcv_cpuconfig_900.c $Rev: 580669 $");
