/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */



#include "startup.h"
#include <ppc/pa6tcpu.h>

	
void
ppcv_cpuconfig1_pa6t(int cpu) {
	uint64_t	hid;

	ppcv_cpuconfig1_900(cpu);
	
	hid = get_spr64(PPCPA6T_SPR_HID5);
	hid &= ~PPCPA6T_SPR_HID5_EN_128B;
	set_spr64(PPCPA6T_SPR_HID5, hid);
}


void
ppcv_cpuconfig2_pa6t(int cpu) {
	ppcv_cpuconfig2_900(cpu);
}

__SRCVERSION("ppcv_cpuconfig_pa6t.c $Rev: 580669 $");
