/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

void
ppcv_cpuinfo_400(struct cpuinfo_entry *cpu) {
	unsigned	flags;
	unsigned	lsize;

	flags = ppcv->cpu_flags;
	if(ppc400_virtual_supported()) {
		flags |= CPU_FLAG_MMU;
	}
	cpu->flags = flags;

	// NOTE: The cache_[i/d]ppc_400 routines are being used only
	// to work around PPC405 errata #37 (fixed in rev D). Once all the
	// old PPC405's are gone, we can use the regular callouts.

	lsize = 1 << ppcv->cache_lsize;
	cpu->data_cache = add_cache(system_dcache_idx,
						CACHE_FLAG_DATA | CACHE_FLAG_WRITEBACK,
						lsize,
						ppcv->dcache_lines,
						&cache_dppc_400);
	cpu->ins_cache = add_cache(system_icache_idx,
						CACHE_FLAG_INSTR,
						lsize,
						ppcv->icache_lines,
						&cache_ippc_400);
}

__SRCVERSION("ppcv_cpuinfo_400.c $Rev: 580669 $");
