/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

void
ppcv_setup_800(void) {
	// 800 series doesn't distinguish between the various implementations
	// in the PVR :-(. Mostly we don't care, except for the 823, which
	// has different instruction and data cache sizes.
	switch(PPC800_GET_PARTNUM) {
	case PPC800_PARTNUM_823:
		ppcv = &ppcv_chip_823;
		break;
	default:
		ppcv = &ppcv_chip_800;
		break;
	}

	ppcv_config.family = PPC_FAMILY_800;
	ppcv_config.cpuconfig1 = &ppcv_cpuconfig1_800;
	ppcv_config.cpuinfo = &ppcv_cpuinfo_800;
	ppcv_config.qtime = &ppc800_pit_init_qtime;
}

__SRCVERSION("ppcv_setup_800.c $Rev: 580669 $");
