/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include "hidpll.h"

void
ppcv_setup_8200(void) {
	ppcv_config.family = PPC_FAMILY_600;
	ppcv_config.cpuconfig1 = &ppcv_cpuconfig1_8200;
	ppcv_config.cpuconfig2 = &ppcv_cpuconfig2_600;
	ppcv_config.cpuinfo = &ppcv_cpuinfo_8200;
	ppcv_config.qtime = &ppc_dec_init_qtime;
	if(shdr->flags1 & STARTUP_HDR_FLAGS1_VIRTUAL) {
		ppcv_config.map = &ppcv_map_600;
		ppcv_config.unmap = &ppcv_unmap_600;
	}
	hid_pll_bits = hid_pll_bits_8200;
}

__SRCVERSION("ppcv_setup_8200.c $Rev: 580669 $");
