/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"
#include <ppc/e500cpu.h>

void
ppcv_setup_e500(void) {
	unsigned	mmucfg = get_spr(PPCBKEM_SPR_MMUCFG);

	ppcbke_tlb.asid_bits = ((mmucfg & PPCBKEM_MMUCFG_PIDSIZE_MASK)
								>> PPCBKEM_MMUCFG_PIDSIZE_SHIFT) + 1;
	ppcbke_tlb.info = ppcbke_tlb_info_motorola;
	ppcbke_tlb.read = ppcbke_tlb_read_e500;
	ppcbke_tlb.write = ppcbke_tlb_write_e500;

	ppcv_setup_booke();
	ppcv_config.cpuconfig1 = &ppcv_cpuconfig1_e500;
	ppcv_config.cpuconfig2 = &ppcv_cpuconfig2_e500;
	ppcv_config.cpuinfo    = &ppcv_cpuinfo_e500;

	ppcbke_register_ivors(32, 4, PPCE500_SPR_IVOR32);

	cpm_offset = 0x80000;
}

__SRCVERSION("ppcv_setup_e500.c $Rev: 580669 $");
