/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */






/* Registers are offsets from the mpic base address */
#define RAVEN_CFG_REG			0x1020
#define RAVEN_IPI_REG_START		0x10a0
#define RAVEN_IPI_VEC_OFF		0x00
#define RAVEN_IPI_REG_SPACING	0x10
#define RAVEN_IPI_NUM			4
#define RAVEN_INT_REG_START		0x10000
#define RAVEN_INT_VEC_OFF		0x00
#define RAVEN_INT_DST_OFF		0x10
#define RAVEN_INT_REG_SPACING	0x20
#define RAVEN_INT_NUM			0x10
#define RAVEN_TIMER_REG_START	0x1100
#define RAVEN_TIMER_CURR_OFF	0x00
#define RAVEN_TIMER_BASE_OFF	0x10
#define RAVEN_TIMER_VEC_OFF		0x20
#define RAVEN_TIMER_DST_OFF		0x30
#define RAVEN_TIMER_REG_SPACING	0x40
#define RAVEN_TIMER_NUM			4
#define RAVEN_TASKPRIO_0		0x20080
#define RAVEN_TASKPRIO_1		0x21080

extern struct callout_rtn	interrupt_id_raven_mpic;
extern struct callout_rtn	interrupt_eoi_raven_mpic;
extern struct callout_rtn	interrupt_mask_raven_mpic;
extern struct callout_rtn	interrupt_unmask_raven_mpic;
extern struct callout_rtn	interrupt_config_raven_mpic;

extern struct callout_rtn	interrupt_id_raven_pib;
extern struct callout_rtn	interrupt_eoi_raven_pib;
extern struct callout_rtn	interrupt_mask_raven_pib;
extern struct callout_rtn	interrupt_unmask_raven_pib;

extern struct callout_rtn 	sendipi_raven;

extern paddr_t	raven_mpic_base;
extern paddr_t	raven_pib_base;

extern void config_raven(paddr_t, paddr_t);

#define RAVEN_INTRS(first_intr)	\
	{ 	first_intr, 16+4+4, _NTO_INTR_SPARE, PPC_EXC_EXTERNAL_INTR, 0, 0,\
		{INTR_GENFLAG_LOAD_CPUNUM, 0, &interrupt_id_raven_mpic},		\
		{INTR_GENFLAG_LOAD_CPUNUM, 0, &interrupt_eoi_raven_mpic},		\
		&interrupt_mask_raven_mpic, &interrupt_unmask_raven_mpic,		\
		&interrupt_config_raven_mpic,									\
		&raven_mpic_base												\
	},																	\
	{ 	first_intr+100, 16, first_intr, PPC_EXC_EXTERNAL_INTR, 0, 0,	\
		{0, 0, &interrupt_id_raven_pib},								\
		{0, 0, &interrupt_eoi_raven_pib},								\
		&interrupt_mask_raven_pib, &interrupt_unmask_raven_pib,			\
		0,																\
		&raven_pib_base,												\
	},

/* __SRCVERSION("raven.h $Rev: 580669 $"); */
