/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */





#include "startup.h"

void
set_spr_indirect(unsigned spr, unsigned value) {
	unsigned	instrs[2];

	spr = (spr >> 5) | ((spr & 0x1f) << 5);
	instrs[0] = 0x7c6003a6 | (spr << 11); 	// mtspr SPR,%r3
	instrs[1] = 0x4e800020;					// blr

	// flush both in case we're crossing a cache boundry.
	icache_flush(&instrs[0]);
	icache_flush(&instrs[1]);

	((void (*)(unsigned))instrs)(value);
}

__SRCVERSION("set_spr_indirect.c $Rev: 580669 $");
