/*
 * $QNXLicenseC:
 * Copyright 2008, QNX Software Systems. 
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"). You 
 * may not reproduce, modify or distribute this software except in 
 * compliance with the License. You may obtain a copy of the License 
 * at: http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTIES OF ANY KIND, either express or implied.
 *
 * This file may contain contributions from others, either as 
 * contributors under the License or as licensors under other terms.  
 * Please review this entire file for other proprietary rights or license 
 * notices, as well as the QNX Development Suite License Guide at 
 * http://licensing.qnx.com/license-guide/ for other information.
 * $
 */




/*
 * PPC8200 interrupt number definitions
 *

 *
 */
#ifndef __PPC_8260INTR_H_INCLUDED
#define __PPC_8260INTR_H_INCLUDED

#include <ppc/intr.h>

/* CLASS GENERAL */
#define PPC8260_INTR_CLASS_GENRAL	_NTO_INTR_CLASS_EXTERNAL
#define PPC8260_INTR_GEN_NONE		(PPC8260_INTR_CLASS_GENRAL	+ 0x0000)
#define PPC8260_INTR_GEN_I2C 		(PPC8260_INTR_CLASS_GENRAL	+ 0x0001)
#define PPC8260_INTR_GEN_SPI 		(PPC8260_INTR_CLASS_GENRAL	+ 0x0002)
#define PPC8260_INTR_GEN_RISCTIMERS	(PPC8260_INTR_CLASS_GENRAL	+ 0x0003)
#define PPC8260_INTR_GEN_SMC1		(PPC8260_INTR_CLASS_GENRAL	+ 0x0004)
#define PPC8260_INTR_GEN_SMC2		(PPC8260_INTR_CLASS_GENRAL	+ 0x0005)
#define PPC8260_INTR_GEN_IDMA1		(PPC8260_INTR_CLASS_GENRAL	+ 0x0006)
#define PPC8260_INTR_GEN_IDMA2		(PPC8260_INTR_CLASS_GENRAL	+ 0x0007)
#define PPC8260_INTR_GEN_IDMA3		(PPC8260_INTR_CLASS_GENRAL	+ 0x0008)
#define PPC8260_INTR_GEN_IDMA4		(PPC8260_INTR_CLASS_GENRAL	+ 0x0009)
#define PPC8260_INTR_GEN_SDMA		(PPC8260_INTR_CLASS_GENRAL	+ 0x000a)
#define PPC8260_INTR_GEN_TMR1		(PPC8260_INTR_CLASS_GENRAL	+ 0x000c)
#define PPC8260_INTR_GEN_TMR2		(PPC8260_INTR_CLASS_GENRAL	+ 0x000d)
#define PPC8260_INTR_GEN_TMR3		(PPC8260_INTR_CLASS_GENRAL	+ 0x000e)
#define PPC8260_INTR_GEN_TMR4		(PPC8260_INTR_CLASS_GENRAL	+ 0x000f)
#define PPC8260_INTR_GEN_TMCNT		(PPC8260_INTR_CLASS_GENRAL	+ 0x0010)
#define PPC8260_INTR_GEN_PIT		(PPC8260_INTR_CLASS_GENRAL	+ 0x0011)
#define PPC8260_INTR_GEN_IRQ1		(PPC8260_INTR_CLASS_GENRAL	+ 0x0013)
#define PPC8260_INTR_GEN_IRQ2		(PPC8260_INTR_CLASS_GENRAL	+ 0x0014)
#define PPC8260_INTR_GEN_IRQ3		(PPC8260_INTR_CLASS_GENRAL	+ 0x0015)
#define PPC8260_INTR_GEN_IRQ4		(PPC8260_INTR_CLASS_GENRAL	+ 0x0016)
#define PPC8260_INTR_GEN_IRQ5		(PPC8260_INTR_CLASS_GENRAL	+ 0x0017)
#define PPC8260_INTR_GEN_IRQ6		(PPC8260_INTR_CLASS_GENRAL	+ 0x0018)
#define PPC8260_INTR_GEN_IRQ7		(PPC8260_INTR_CLASS_GENRAL	+ 0x0019)
#define PPC8260_INTR_GEN_FCC1		(PPC8260_INTR_CLASS_GENRAL	+ 0x0020)
#define PPC8260_INTR_GEN_FCC2		(PPC8260_INTR_CLASS_GENRAL	+ 0x0021)
#define PPC8260_INTR_GEN_FCC3		(PPC8260_INTR_CLASS_GENRAL	+ 0x0022)
#define PPC8260_INTR_GEN_MCC1		(PPC8260_INTR_CLASS_GENRAL	+ 0x0024)
#define PPC8260_INTR_GEN_MCC2		(PPC8260_INTR_CLASS_GENRAL	+ 0x0025)
#define PPC8260_INTR_GEN_SCC1		(PPC8260_INTR_CLASS_GENRAL	+ 0x0028)
#define PPC8260_INTR_GEN_SCC2		(PPC8260_INTR_CLASS_GENRAL	+ 0x0029)
#define PPC8260_INTR_GEN_SCC3		(PPC8260_INTR_CLASS_GENRAL	+ 0x002a)
#define PPC8260_INTR_GEN_SCC4		(PPC8260_INTR_CLASS_GENRAL	+ 0x002b)
#define PPC8260_INTR_GEN_PC15		(PPC8260_INTR_CLASS_GENRAL	+ 0x0030)
#define PPC8260_INTR_GEN_PC14		(PPC8260_INTR_CLASS_GENRAL	+ 0x0031)
#define PPC8260_INTR_GEN_PC13		(PPC8260_INTR_CLASS_GENRAL	+ 0x0032)
#define PPC8260_INTR_GEN_PC12		(PPC8260_INTR_CLASS_GENRAL	+ 0x0033)
#define PPC8260_INTR_GEN_PC11		(PPC8260_INTR_CLASS_GENRAL	+ 0x0034)
#define PPC8260_INTR_GEN_PC10		(PPC8260_INTR_CLASS_GENRAL	+ 0x0035)
#define PPC8260_INTR_GEN_PC9		(PPC8260_INTR_CLASS_GENRAL	+ 0x0036)
#define PPC8260_INTR_GEN_PC8		(PPC8260_INTR_CLASS_GENRAL	+ 0x0037)
#define PPC8260_INTR_GEN_PC7		(PPC8260_INTR_CLASS_GENRAL	+ 0x0038)
#define PPC8260_INTR_GEN_PC6		(PPC8260_INTR_CLASS_GENRAL	+ 0x0039)
#define PPC8260_INTR_GEN_PC5		(PPC8260_INTR_CLASS_GENRAL	+ 0x003a)
#define PPC8260_INTR_GEN_PC4		(PPC8260_INTR_CLASS_GENRAL	+ 0x003b)
#define PPC8260_INTR_GEN_PC3		(PPC8260_INTR_CLASS_GENRAL	+ 0x003c)
#define PPC8260_INTR_GEN_PC2		(PPC8260_INTR_CLASS_GENRAL	+ 0x003d)
#define PPC8260_INTR_GEN_PC1		(PPC8260_INTR_CLASS_GENRAL	+ 0x003e)
#define PPC8260_INTR_GEN_PC0		(PPC8260_INTR_CLASS_GENRAL	+ 0x003f)
#define PPC8260_INTR_CLASS_GEN_TOTAL	(PPC8260_INTR_GEN_PC0 - PPC8260_INTR_CLASS_GENRAL + 1)

#endif

/* __SRCVERSION("8260intr.h $Rev: 580669 $"); */
