/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __TGEC_MII_ACC_H
#define __TGEC_MII_ACC_H

#include "std_ext.h"


/* MII  Management Command Register */
#define MIIMCOM_READ_POST_INCREMENT 0x00004000
#define MIIMCOM_READ_CYCLE          0x00008000
#define MIIMCOM_SCAN_CYCLE          0x00000800
#define MIIMCOM_PREAMBLE_DISABLE    0x00000400

#define MIIMCOM_MDIO_HOLD_1_REG_CLK 0
#define MIIMCOM_MDIO_HOLD_2_REG_CLK 1
#define MIIMCOM_MDIO_HOLD_3_REG_CLK 2
#define MIIMCOM_MDIO_HOLD_4_REG_CLK 3

#define MIIMCOM_DIV_MASK            0x0000ff00
#define MIIMCOM_DIV_SHIFT           8

/* MII Management Indicator Register */
#define MIIMIND_BUSY                0x00000001
#define MIIMIND_READ_ERROR          0x00000002

#define MIIDATA_BUSY                0x80000000

#if defined(__MWERKS__) && !defined(__GNUC__)
#pragma pack(push,1)
#endif /* defined(__MWERKS__) && ... */
#define MEM_MAP_START

/*----------------------------------------------------*/
/* MII Configuration Control Memory Map Registers     */
/*----------------------------------------------------*/
typedef _Packed struct t_TgecMiiAccessMemMap
{
    volatile uint32_t   mdio_cfg_status;    /* 0x030  */
    volatile uint32_t   mdio_command;       /* 0x034  */
    volatile uint32_t   mdio_data;          /* 0x038  */
    volatile uint32_t   mdio_regaddr;       /* 0x03c  */
} _PackedType t_TgecMiiAccessMemMap ;

#define MEM_MAP_END
#if defined(__MWERKS__) && !defined(__GNUC__)
#pragma pack(pop)
#endif /* defined(__MWERKS__) && ... */


#endif /* __TGEC_MII_ACC_H */
