/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#error "Please don't use this file. It is Obsolete. Use e500v2_ext.h instead"
#ifndef __BOOKE_SPRS_H
#define __BOOKE_SPRS_H


/*
*
* Book E Special-Purpose Registers (by SPR Abbreviation)
*/
#define CSRR0 58        /* Critical save/restore register 0 */
#define CSRR1 59        /* Critical save/restore register 1 */
#define CTR 9           /* Count register */
#define DAC1 316        /* Data address compare 1 */
#define DAC2 317        /* Data address compare 2 */
#define DBCR0 308       /* Debug control register 0 1 */
#define DBCR1 309       /* Debug control register 1 1 */
#define DBCR2 310       /* Debug control register 2 1 */
#define DBSR 304        /* Debug status register */
#define DEAR 61         /* Data exception address register */
#define DEC 22          /* Decrementer */
#define DECAR 54        /* Decrementer auto-reload */
#define ESR 62          /* Exception syndrome register */
#define IAC1 312        /* Instruction address compare 1 */
#define IAC2 313        /* Instruction address compare 2 */
#define IVOR0 400       /* Critical input */
#define IVOR1 401       /* Machine check interrupt offset */
#define IVOR2 402       /* Data storage interrupt offset */
#define IVOR3 403       /* Instruction storage interrupt offset */
#define IVOR4 404       /* External input interrupt offset */
#define IVOR5 405       /* Alignment interrupt offset */
#define IVOR6 406       /* Program interrupt offset */
#define IVOR8 408       /* System call interrupt offset */
#define IVOR10 410      /* Decrementer interrupt offset */
#define IVOR11 411      /* Fixed-interval timer interrupt offset */
#define IVOR12 412      /* Watchdog timer interrupt offset */
#define IVOR13 413      /* Data TLB error interrupt offset */
#define IVOR14 414      /* Instruction TLB error interrupt offset */
#define IVOR15 415      /* Debug interrupt offset */
#define IVPR 63         /* Interrupt vector */
#define LR 8            /* Link register */
#define PID 48          /* Process ID register 3 */
#define PIR 286         /* Processor ID register */
#define PVR 287         /* Processor version register */
#define SPRG0 272       /* SPR general 0 */
#define SPRG1 273       /* SPR general 1 */
#define SPRG2 274       /* SPR general 2 */
#define SPRG3 275       /* SPR general 3 */
#define SPRG4 276       /* SPR general 4 */
#define SPRG5 277       /* SPR general 5 */
#define SPRG6 278       /* SPR general 6 */
#define SPRG7 279       /* SPR general 7 */
#define SRR0 26         /* Save/restore register 0 */
#define SRR1 27         /* Save/restore register 1 */
#define TBL 284         /* Time base lower */
#define TBU 285         /* Time base upper */
#define TCR 340         /* Timer control register */
#define TSR 336         /* Timer status register */
#define USPRG0 256      /* User SPR general 06 */
#define XER 1           /* Integer exception register */


/*
*
* Implementation-Specific SPRs (by SPR Abbreviation)
*
*/

#define BBEAR 513       /* Branch buffer entry address register 1 */
#define BBTAR 514       /* Branch buffer target address register 1 */
#define BUCSR 1013      /* Branch unit control and status register 1 */
#define HID0 1008       /* Hardware implementation dependent reg 0 1 */
#define HID1 1009       /* Hardware implementation dependent reg 1 1 */
#define IVOR32 528      /* SPE APU unavailable interrupt offset */
#define IVOR33 529      /* Floating-point data exception interrupt offset */
#define IVOR34 530      /* Floating-point round exception interrupt offset */
#define IVOR35 531      /* Performance monitor */
#define L1CFG0 515      /* L1 cache configuration register 0 */
#define L1CFG1 516      /* L1 cache configuration register 1 */
#define L1CSR0 1010         /* L1 cache control and status register 0 1 */
#define L1CSR1 1011         /* L1 cache control and status register 1 1 */
#define MAS0 624        /* MMU assist register 0 1 */
#define MAS1 625        /* MMU assist register 1 1 */
#define MAS2 626        /* MMU assist register 2 1 */
#define MAS3 627        /* MMU assist register 3 1 */
#define MAS4 628        /* MMU assist register 4 1 */
#define MAS5 339        /* MMU assist register 5 1 */
#define MAS6 630        /* MMU assist register 6 1 */
#define MAS7 944        /* MMU assist register 7 1 */
#define MAS8 341        /* MMU assist register 8 1 */
#define MCAR 573        /* Machine check address register */
#define MCSR 572        /* Machine check syndrome register */
#define MCSRR0 570      /* Machine check save/restore register 0 */
#define MCSRR1 571      /* Machine check save/restore register 1 */
#define MMUCFG 1015     /* MMU configuration register */
#define MMUCSR0 1012    /* MMU control and status register 0 1 */


/* #define PID 48       /* Book E refers to this as instead of PID0.*/
#define PID0 48         /* Process ID register 0. */
#define PID1 633        /* Process ID register 1 1 */
#define PID2 634        /* Process ID register 2 1 */
#define SPEFSCR 512     /* Signal processing and embedded floating-point status and control register 1 */
#define SVR 1023        /* System version register */
#define ILLEGAL  333    /* For test only */


#ifndef RUN_FROM_ASM
/*
 *External Function Definitions.
 *
 */
/*
*
* Book E Special-Purpose Registers (by SPR Abbreviation)
*/
uint32_t E500_GetSPR_CSRR0(void);   /* 58       /* Critical save/restore register 0 */
void E500_SetSPR_CSRR0(uint32_t newvalue);  /* 58       /* Critical save/restore register 0 */
uint32_t E500_GetSPR_CSRR1(void);   /* 59       /* Critical save/restore register 1 */
void E500_SetSPR_CSRR1(uint32_t newvalue);  /* 59       /* Critical save/restore register 1 */
uint32_t E500_GetSPR_CTR(void);     /* 9        /* Count register */
void E500_SetSPR_CTR(uint32_t newvalue);        /* 9        /* Count register */
uint32_t E500_GetSPR_DAC1(void);    /* 316      /* Data address compare 1 */
void E500_SetSPR_DAC1(uint32_t newvalue);   /* 316      /* Data address compare 1 */
uint32_t E500_GetSPR_DAC2(void);    /* 317      /* Data address compare 2 */
void E500_SetSPR_DAC2(uint32_t newvalue);   /* 317      /* Data address compare 2 */
uint32_t E500_GetSPR_DBCR0(void);   /* 308      /* Debug control register 0 1 */
void E500_SetSPR_DBCR0(uint32_t newvalue);  /* 308      /* Debug control register 0 1 */
uint32_t E500_GetSPR_DBCR1(void);   /* 309      /* Debug control register 1 1 */
void E500_SetSPR_DBCR1(uint32_t newvalue);  /* 309      /* Debug control register 1 1 */
uint32_t E500_GetSPR_DBCR2(void);   /* 310      /* Debug control register 2 1 */
void E500_SetSPR_DBCR2(uint32_t newvalue);  /* 310      /* Debug control register 2 1 */
uint32_t E500_GetSPR_DBSR(void);    /* 304      /* Debug status register */
void E500_SetSPR_DBSR(uint32_t newvalue);   /* 304      /* Debug status register */
uint32_t E500_GetSPR_DEAR(void);    /* 61       /* Data exception address register */
void E500_SetSPR_DEAR(uint32_t newvalue);   /* 61       /* Data exception address register */
uint32_t E500_GetSPR_DEC(void);     /* 22       /* Decrementer */
void E500_SetSPR_DEC(uint32_t newvalue);        /* 22       /* Decrementer */
uint32_t E500_GetSPR_DECAR(void);   /* 54       /* Decrementer auto-reload */
void E500_SetSPR_DECAR(uint32_t newvalue);  /* 54       /* Decrementer auto-reload */
uint32_t E500_GetSPR_ESR(void);     /* 62       /* Exception syndrome register */
void E500_SetSPR_ESR(uint32_t newvalue);        /* 62       /* Exception syndrome register */
uint32_t E500_GetSPR_IAC1(void);    /* 312      /* Instruction address compare 1 */
void E500_SetSPR_IAC1(uint32_t newvalue);   /* 312      /* Instruction address compare 1 */
uint32_t E500_GetSPR_IAC2(void);    /* 313      /* Instruction address compare 2 */
void E500_SetSPR_IAC2(uint32_t newvalue);   /* 313      /* Instruction address compare 2 */
uint32_t E500_GetSPR_IVOR0(void);   /* 400      /* Critical input */
void E500_SetSPR_IVOR0(uint32_t newvalue);  /* 400      /* Critical input */
uint32_t E500_GetSPR_IVOR1(void);   /* 401      /* Machine check interrupt offset */
void E500_SetSPR_IVOR1(uint32_t newvalue);  /* 401      /* Machine check interrupt offset */
uint32_t E500_GetSPR_IVOR2(void);   /* 402      /* Data storage interrupt offset */
void E500_SetSPR_IVOR2(uint32_t newvalue);  /* 402      /* Data storage interrupt offset */
uint32_t E500_GetSPR_IVOR3(void);   /* 403      /* Instruction storage interrupt offset */
void E500_SetSPR_IVOR3(uint32_t newvalue);  /* 403      /* Instruction storage interrupt offset */
uint32_t E500_GetSPR_IVOR4(void);   /* 404      /* External input interrupt offset */
void E500_SetSPR_IVOR4(uint32_t newvalue);  /* 404      /* External input interrupt offset */
uint32_t E500_GetSPR_IVOR5(void);   /* 405      /* Alignment interrupt offset */
void E500_SetSPR_IVOR5(uint32_t newvalue);  /* 405      /* Alignment interrupt offset */
uint32_t E500_GetSPR_IVOR6(void);   /* 406      /* Program interrupt offset */
void E500_SetSPR_IVOR6(uint32_t newvalue);  /* 406      /* Program interrupt offset */
uint32_t E500_GetSPR_IVOR8(void);   /* 408      /* System call interrupt offset */
void E500_SetSPR_IVOR8(uint32_t newvalue);  /* 408      /* System call interrupt offset */
uint32_t E500_GetSPR_IVOR10(void);  /* 410      /* Decrementer interrupt offset */
void E500_SetSPR_IVOR10(uint32_t newvalue); /* 410      /* Decrementer interrupt offset */
uint32_t E500_GetSPR_IVOR11(void);  /* 411      /* Fixed-interval timer interrupt offset */
void E500_SetSPR_IVOR11(uint32_t newvalue); /* 411      /* Fixed-interval timer interrupt offset */
uint32_t E500_GetSPR_IVOR12(void);  /* 412      /* Watchdog timer interrupt offset */
void E500_SetSPR_IVOR12(uint32_t newvalue); /* 412      /* Watchdog timer interrupt offset */
uint32_t E500_GetSPR_IVOR13(void);  /* 413      /* Data TLB error interrupt offset */
void E500_SetSPR_IVOR13(uint32_t newvalue); /* 413      /* Data TLB error interrupt offset */
uint32_t E500_GetSPR_IVOR14(void);  /* 414      /* Instruction TLB error interrupt offset */
void E500_SetSPR_IVOR14(uint32_t newvalue); /* 414      /* Instruction TLB error interrupt offset */
uint32_t E500_GetSPR_IVOR15(void);  /* 415      /* Debug interrupt offset */
void E500_SetSPR_IVOR15(uint32_t newvalue); /* 415      /* Debug interrupt offset */
uint32_t E500_GetSPR_IVPR(void);    /* 63       /* Interrupt vector */
void E500_SetSPR_IVPR(uint32_t newvalue);   /* 63       /* Interrupt vector */
uint32_t E500_GetSPR_LR(void);      /* 8        /* Link register */
void E500_SetSPR_LR(uint32_t newvalue);     /* 8        /* Link register */
uint32_t E500_GetSPR_PID(void);     /* 48       /* Process ID register 3 */
void E500_SetSPR_PID(uint32_t newvalue);        /* 48       /* Process ID register 3 */
uint32_t E500_GetSPR_PIR(void);     /* 286      /* Processor ID register */
void E500_SetSPR_PIR(uint32_t newvalue);        /* 286      /* Processor ID register */
uint32_t E500_GetSPR_PVR(void);     /* 287      /* Processor version register */
void E500_SetSPR_PVR(uint32_t newvalue);        /* 287      /* Processor version register */
uint32_t E500_GetSPR_SPRG0(void);   /* 272      /* SPR general 0 */
void E500_SetSPR_SPRG0(uint32_t newvalue);  /* 272      /* SPR general 0 */
uint32_t E500_GetSPR_SPRG1(void);   /* 273      /* SPR general 1 */
void E500_SetSPR_SPRG1(uint32_t newvalue);  /* 273      /* SPR general 1 */
uint32_t E500_GetSPR_SPRG2(void);   /* 274      /* SPR general 2 */
void E500_SetSPR_SPRG2(uint32_t newvalue);  /* 274      /* SPR general 2 */
uint32_t E500_GetSPR_SPRG3(void);   /* 275      /* SPR general 3 */
void E500_SetSPR_SPRG3(uint32_t newvalue);  /* 275      /* SPR general 3 */
uint32_t E500_GetSPR_SPRG4(void);   /* 276      /* SPR general 4 */
void E500_SetSPR_SPRG4(uint32_t newvalue);  /* 276      /* SPR general 4 */
uint32_t E500_GetSPR_SPRG5(void);   /* 277      /* SPR general 5 */
void E500_SetSPR_SPRG5(uint32_t newvalue);  /* 277      /* SPR general 5 */
uint32_t E500_GetSPR_SPRG6(void);   /* 278      /* SPR general 6 */
void E500_SetSPR_SPRG6(uint32_t newvalue);  /* 278      /* SPR general 6 */
uint32_t E500_GetSPR_SPRG7(void);   /* 279      /* SPR general 7 */
void E500_SetSPR_SPRG7(uint32_t newvalue);  /* 279      /* SPR general 7 */
uint32_t E500_GetSPR_SRR0(void);    /* 26       /* Save/restore register 0 */
void E500_SetSPR_SRR0(uint32_t newvalue);   /* 26       /* Save/restore register 0 */
uint32_t E500_GetSPR_SRR1(void);    /* 27       /* Save/restore register 1 */
void E500_SetSPR_SRR1(uint32_t newvalue);   /* 27       /* Save/restore register 1 */
uint32_t E500_GetSPR_TBL(void);     /* 284      /* Time base lower */
void E500_SetSPR_TBL(uint32_t newvalue);        /* 284      /* Time base lower */
uint32_t E500_GetSPR_TBU(void);     /* 285      /* Time base upper */
void E500_SetSPR_TBU(uint32_t newvalue);        /* 285      /* Time base upper */
uint32_t E500_GetSPR_TCR(void);     /* 340      /* Timer control register */
void E500_SetSPR_TCR(uint32_t newvalue);        /* 340      /* Timer control register */
uint32_t E500_GetSPR_TSR(void);     /* 336      /* Timer status register */
void E500_SetSPR_TSR(uint32_t newvalue);        /* 336      /* Timer status register */
uint32_t E500_GetSPR_USPRG0(void);  /* 256      /* User SPR general 06 */
void E500_SetSPR_USPRG0(uint32_t newvalue); /* 256      /* User SPR general 06 */
uint32_t E500_GetSPR_XER(void);     /* 1        /* Integer exception register */
void E500_SetSPR_XER(uint32_t newvalue);        /* 1        /* Integer exception register */


/*
*
* Implementation-Specific SPRs (by SPR Abbreviation)
*
*/

uint32_t E500_GetSPR_BBEAR(void);   /* 513      /* Branch buffer entry address register 1 */
void E500_SetSPR_BBEAR(uint32_t newvalue);  /* 513      /* Branch buffer entry address register 1 */
uint32_t E500_GetSPR_BBTAR(void);   /* 514      /* Branch buffer target address register 1 */
void E500_SetSPR_BBTAR(uint32_t newvalue);  /* 514      /* Branch buffer target address register 1 */
uint32_t E500_GetSPR_BUCSR(void);   /* 1013     /* Branch unit control and status register 1 */
void E500_SetSPR_BUCSR(uint32_t newvalue);  /* 1013     /* Branch unit control and status register 1 */
uint32_t E500_GetSPR_HID0(void);    /* 1008     /* Hardware implementation dependent reg 0 1 */
void E500_SetSPR_HID0(uint32_t newvalue);   /* 1008     /* Hardware implementation dependent reg 0 1 */
uint32_t E500_GetSPR_HID1(void);    /* 1009     /* Hardware implementation dependent reg 1 1 */
void E500_SetSPR_HID1(uint32_t newvalue);   /* 1009     /* Hardware implementation dependent reg 1 1 */
uint32_t E500_GetSPR_IVOR32(void);  /* 528      /* SPE APU unavailable interrupt offset */
void E500_SetSPR_IVOR32(uint32_t newvalue); /* 528      /* SPE APU unavailable interrupt offset */
uint32_t E500_GetSPR_IVOR33(void);  /* 529      /* Floating-point data exception interrupt offset */
void E500_SetSPR_IVOR33(uint32_t newvalue); /* 529      /* Floating-point data exception interrupt offset */
uint32_t E500_GetSPR_IVOR34(void);  /* 530      /* Floating-point round exception interrupt offset */
void E500_SetSPR_IVOR34(uint32_t newvalue); /* 530      /* Floating-point round exception interrupt offset */
uint32_t E500_GetSPR_IVOR35(void);  /* 531      /* Performance monitor */
void E500_SetSPR_IVOR35(uint32_t newvalue); /* 531      /* Performance monitor */
uint32_t E500_GetSPR_L1CFG0(void);  /* 515      /* L1 cache configuration register 0 */
void E500_SetSPR_L1CFG0(uint32_t newvalue); /* 515      /* L1 cache configuration register 0 */
uint32_t E500_GetSPR_L1CFG1(void);  /* 516      /* L1 cache configuration register 1 */
void E500_SetSPR_L1CFG1(uint32_t newvalue); /* 516      /* L1 cache configuration register 1 */
uint32_t E500_GetSPR_L1CSR0(void);  /* 1010     /* L1 cache control and status register 0 1 */
void E500_SetSPR_L1CSR0(uint32_t newvalue); /* 1010     /* L1 cache control and status register 0 1 */
uint32_t E500_GetSPR_L1CSR1(void);  /* 1011     /* L1 cache control and status register 1 1 */
void E500_SetSPR_L1CSR1(uint32_t newvalue); /* 1011     /* L1 cache control and status register 1 1 */
uint32_t E500_GetSPR_MAS0(void);    /* 624      /* MMU assist register 0 1 */
void E500_SetSPR_MAS0(uint32_t newvalue);   /* 624      /* MMU assist register 0 1 */
uint32_t E500_GetSPR_MAS1(void);    /* 625      /* MMU assist register 1 1 */
void E500_SetSPR_MAS1(uint32_t newvalue);   /* 625      /* MMU assist register 1 1 */
uint32_t E500_GetSPR_MAS2(void);    /* 626      /* MMU assist register 2 1 */
void E500_SetSPR_MAS2(uint32_t newvalue);   /* 626      /* MMU assist register 2 1 */
uint32_t E500_GetSPR_MAS3(void);    /* 627      /* MMU assist register 3 1 */
void E500_SetSPR_MAS3(uint32_t newvalue);   /* 627      /* MMU assist register 3 1 */
uint32_t E500_GetSPR_MAS4(void);    /* 628      /* MMU assist register 4 1 */
void E500_SetSPR_MAS4(uint32_t newvalue);   /* 628      /* MMU assist register 4 1 */
uint32_t E500_GetSPR_MAS6(void);    /* 630      /* MMU assist register 6 1 */
void E500_SetSPR_MAS6(uint32_t newvalue);   /* 630      /* MMU assist register 6 1 */
uint32_t E500_GetSPR_MAS7(void);    /* 944      /* MMU assist register 7 1 */
void E500_SetSPR_MAS7(uint32_t newvalue);   /* 944      /* MMU assist register 7 1 */
uint32_t E500_GetSPR_MCAR(void);    /* 573      /* Machine check address register */
void E500_SetSPR_MCAR(uint32_t newvalue);   /* 573      /* Machine check address register */
uint32_t E500_GetSPR_MCSR(void);    /* 572      /* Machine check syndrome register */
void E500_SetSPR_MCSR(uint32_t newvalue);   /* 572      /* Machine check syndrome register */
uint32_t E500_GetSPR_MCSRR0(void);  /* 570      /* Machine check save/restore register 0 */
void E500_SetSPR_MCSRR0(uint32_t newvalue); /* 570      /* Machine check save/restore register 0 */
uint32_t E500_GetSPR_MCSRR1(void);  /* 571      /* Machine check save/restore register 1 */
void E500_SetSPR_MCSRR1(uint32_t newvalue); /* 571      /* Machine check save/restore register 1 */
uint32_t E500_GetSPR_MMUCFG(void);  /* 1015     /* MMU configuration register */
void E500_SetSPR_MMUCFG(uint32_t newvalue); /* 1015     /* MMU configuration register */
uint32_t E500_GetSPR_MMUCSR0(void); /* 1012     /* MMU control and status register 0 1 */
void E500_SetSPR_MMUCSR0(uint32_t newvalue);    /* 1012     /* MMU control and status register 0 1 */

uint32_t E500_GetSPR_TLB0CFG(void);     /* 688      /* TLB0CFG register 0. */
uint32_t E500_GetSPR_TLB1CFG(void);     /* 689      /* TLB1CFG register 0. */


uint32_t E500_GetSPR_PID0(void);    /* 48       /* Process ID register 0. */
void E500_SetSPR_PID0(uint32_t newvalue);   /* 48       /* Process ID register 0. */
uint32_t E500_GetSPR_PID1(void);    /* 633      /* Process ID register 1 1 */
void E500_SetSPR_PID1(uint32_t newvalue);   /* 633      /* Process ID register 1 1 */
uint32_t E500_GetSPR_PID2(void);    /* 634      /* Process ID register 2 1 */
void E500_SetSPR_PID2(uint32_t newvalue);   /* 634      /* Process ID register 2 1 */
uint32_t E500_GetSPR_SPEFSCR(void); /* 512      /* Signal processing and embedded floating-point status and control register 1 */
void E500_SetSPR_SPEFSCR(uint32_t newvalue);    /* 512      /* Signal processing and embedded floating-point status and control register 1 */
uint32_t E500_GetSPR_SVR(void);     /* 1023     /* System version register */
void E500_SetSPR_SVR(uint32_t newvalue);        /* 1023     /* System version register */
uint32_t E500_GetSPR_ILLEGAL(void);     /* 999  /* System version register */
void E500_SetSPR_ILLEGAL(uint32_t newvalue);        /* 999  /* System version register */
void E500_ILLEGAL_Inst(void);
#endif



#endif /* __BOOKE_SPRS_H */
