/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __MMU_H
#define __MMU_H

#define __ERR_MODULE__  MODULE_MMU

/* Updated for E500V2
 * ==================
 * In case of E500V1 values should be updated.
 */
#define TLB1                    0x10000000
#ifdef CORE_E500MC
#define TLB1_NUM_OF_ENTRIES     64
#else
#define TLB1_NUM_OF_ENTRIES     16
#endif /* CORE_E500MC */
#define TLB0_NUM_OF_ENTRIES_V2      512
#define TLB0_NUM_OF_ENTRIES_V1      256             /* 256 for e500V1 */
#define TLB0                    0x00000000
#define TLB0_NUM_OF_WAYS        4


/*RD Original MAS0.
#define MAS0_TLB1_ESEL_SHIFT    16
#define MAS0_ESEL_MASK          0x000F0000
#define MAS0_TLB0_ESEL_SHIFT    12
#define MAS0_TLB0_WAY_SHIFT     16
#define MAS0_NV                 0x00000001
*/
#define MAS0_TLB_ESEL_SHIFT     16
#define MAS0_ESEL_MASK          0x000F0000
#define MAS0_TLBSEL             0x10000000
#define MAS0_NV                 0x00000001

#define MAS1_TLB_VALID          0x80000000
#define MAS1_IPROT              0x40000000
#define MAS1_TID_MASK           0x00ff0000
#define MAS1_TID_SHIFT          16
#define MAS1_TS                 0x00001000
#define MAS1_TSIZE_MASK         0x00000F00
#define MAS1_TSIZE_SHIFT        8

/*RD Original MAS0.
#define MAS2_SHAREN             0x00000200
*/
#define MAS2_X0                 0x00000040
#define MAS2_X1                 0x00000020
#define MAS2_W                  0x00000010
#define MAS2_I                  0x00000008
#define MAS2_M                  0x00000004
#define MAS2_G                  0x00000002
#define MAS2_E                  0x00000001
#define MAS2_EPN_MASK           0xFFFFF000
#define MAS2_EPN_SHIFT          12

#define MAS3_RPN_MASK           0xFFFFF000
#define PAGE_SIZE(tsize)        ((uint32_t)(1<<(2*tsize +10))) /* 4^tsize*1024 */
#define MAS3_PERMIS_MASK        (e_MMU_MAS3_USER_X |\
                                e_MMU_MAS3_USER_W |\
                                e_MMU_MAS3_USER_R |\
                                e_MMU_MAS3_SUPERVISOR_X |\
                                e_MMU_MAS3_SUPERVISOR_W |\
                                e_MMU_MAS3_SUPERVISOR_R)

#endif /* __MMU_H */
