/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __E500V2_PM_H
#define __E500V2_PM_H

#include "e500v2_pm_ext.h"

#define __ERR_MODULE__  MODULE_CORE

/* Updated for E500V2
 * ==================
 * In case of E500V1 values should be updated.
 */


#define E500_PM_MAX_COUNTER      4

#define E500_PM_PMGC0_FAC        0x80000000          /* Freeze all counters.*/
#define E500_PM_PMGC0_PMIE       0x40000000          /* Performance monitor interrupt enable */
#define E500_PM_PMGC0_FCECE      0x20000000          /* Freeze counters on enabled condition or event */
#define E500_PM_PMGC0_TBSEL_0    0x00000000          /* Time base selector. 0*/
#define E500_PM_PMGC0_TBSEL_1    0x00000800          /* Time base selector. 1*/
#define E500_PM_PMGC0_TBSEL_2    0x00001000          /* Time base selector. 2*/
#define E500_PM_PMGC0_TBSEL_3    0x00001800          /* Time base selector. 3*/
#define E500_PM_PMGC0_TBSEL_MASK E500_PM_PMGC0_TBSEL_3    /* Time base selector mask*/
#define E500_PM_PMGC0_TBEE       0x00000100          /* Time base transition event exception enable */




#define E500_PM_PMLCA_FC           0x80000000
#define E500_PM_PMLCA_FCS          0x40000000
#define E500_PM_PMLCA_FCU          0x20000000
#define E500_PM_PMLCA_FCM1         0x10000000
#define E500_PM_PMLCA_FCM0         0x08000000
#define E500_PM_PMLCA_CE           0x04000000
#define E500_PM_PMLCA_EVENT_SHIFT  16

#define E500_PM_MAX_THRESHMUL      e_E500_PM_THRESHMUL_128
#define E500_PM_MAX_THRESHOLD      0x3F
#define E500_PM_THRESHMUL_SHIFT    4

#define E500_PM_PMC_OVERFLOW       0x80000000 /* set the overflow bit in the PMC register */

#endif /* #ifndef __E500V2_PM_H */
