/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
 /**************************************************************************//*

 @File          cq.h

 @Description   Circular Queue header file

                The header file contains the structure of the queue

 @Cautions      None.
 *//***************************************************************************/


#ifndef __CQ_H
#define __CQ_H


/**************************************************************************//**
 @Description   Circular queue structure
*//***************************************************************************/
typedef struct t_Cq
{
    uint16_t        maxItems;       /**< Size of queue */
    uint16_t        itemSize;       /**< Size of each item in the queue */
    uint16_t        itemsInQueue;   /**< Number of items currently in the queue */
    uint16_t        first;          /**< Index of first item in queue */

#ifdef DEBUG
    uint16_t        putFailures;    /**< Number of failed put operations */
    uint16_t        maxIn;          /**< Maximum items that have been in the queue at one time */
#endif /* not DEBUG */

    uint8_t         items[1];       /**< Holds the elements in the queue - fake size;
                                         (this field must be 4-bytes aligned) */
} t_Cq;

/** @} */ /* end of cq_id group */


#endif /* __CQ_H */


