/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**

 @File          list.c

 @Description   Implementation of list.
*//***************************************************************************/
#include "std_ext.h"
#include "list_ext.h"


void LIST_Append(t_List *p_NewList, t_List *p_Head)
{
    t_List *p_First = LIST_FIRST(p_NewList);

    if (p_First != p_NewList)
    {
        t_List *p_Last  = LIST_LAST(p_NewList);
        t_List *p_Cur   = LIST_NEXT(p_Head);

        LIST_PREV(p_First) = p_Head;
        LIST_FIRST(p_Head) = p_First;
        LIST_NEXT(p_Last)  = p_Cur;
        LIST_LAST(p_Cur)   = p_Last;
    }
}


int LIST_NumOfObjs(t_List *p_List)
{
    t_List *p_Tmp;
    int    numOfObjs = 0;

    if (!LIST_IsEmpty(p_List))
        LIST_FOR_EACH(p_Tmp, p_List)
            numOfObjs++;

    return numOfObjs;
}
