/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __MEM_H
#define __MEM_H

#include "error_ext.h"
#include "std_ext.h"
#include "list_ext.h"


#define __ERR_MODULE__  MODULE_MEM




/**************************************************************************//**
 @Description   Memory allocation owner.
*//***************************************************************************/
typedef enum e_MemAllocOwner
{
    e_MEM_ALLOC_OWNER_LOCAL,
    e_MEM_ALLOC_OWNER_LOCAL_SMART,
    e_MEM_ALLOC_OWNER_EXTERNAL
} e_MemAllocOwner;


#ifdef DEBUG_MEM_LEAKS

/**************************************************************************//**
 @Description   MEM block information for leaks detection.
*//***************************************************************************/
typedef struct t_MemDbg
{
    uint32_t    ownerAddress;

} t_MemDbg;

#endif /* DEBUG_MEM_LEAKS */


#endif /* __MEM_H */
