/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/*------------------------------------------------------*/
/*                                                      */
/* File: sprint.c                                       */
/*                                                      */
/* Description:                                         */
/*    Debug routines (externals)                        */
/*                                                      */
/* Modifications:                                       */
/* ==============                                       */
/*                                                      */
/*------------------------------------------------------*/
#include "string_ext.h"
#include "stdlib_ext.h"
#include "ctype_ext.h"
#include "stdarg_ext.h"
#include "sprint_ext.h"
#include "std_ext.h"
#include "xx_ext.h"


int Sprint(char * buf, const char *fmt, ...)
{
    va_list args;
    int i;

    va_start(args, fmt);
#if (defined(__MWERKS__) && defined(__GNUC__))
/* TODO - remove it from here!!! */
extern void MSR_EnableFP(void);
MSR_EnableFP();
#endif /* (defined(__MWERKS__) && ... */
    i=vsprintf(buf,fmt,args);
    va_end(args);
    return i;
}


int Snprint(char * buf, uint32_t size, const char *fmt, ...)
{
    va_list args;
    int i;

    va_start(args, fmt);
    i=vsnprintf(buf,size,fmt,args);
    va_end(args);
    return i;
}


int Sscan(const char * buf, const char * fmt, ...)
{
    va_list args;
    int i;

    va_start(args,fmt);
    i = vsscanf(buf,fmt,args);
    va_end(args);
    return i;
}
