/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/

#ifndef __MII_ACC_EXT_H
#define __MII_ACC_EXT_H


/**************************************************************************//**
 @Function      MII_ReadPhyReg

 @Description   This routine is called to read a specified PHY
                register value.

 @Param[in]     h_MiiAccess - Handle to MII configuration access registers
 @Param[in]     phyAddr     - PHY address (0-31).
 @Param[in]     reg         - PHY register to read
 @Param[out]    p_Data      - Gets the register value.

 @Return        Always zero (success).
*//***************************************************************************/
int MII_ReadPhyReg(t_Handle h_MiiAccess,
                   uint8_t  phyAddr,
                   uint8_t  reg,
                   uint16_t *p_Data);

/**************************************************************************//**
 @Function      MII_WritePhyReg

 @Description   This routine is called to write data to a specified PHY
                   register.

 @Param[in]     h_MiiAccess - Handle to MII configuration access registers
 @Param[in]     phyAddr     - PHY address (0-31).
 @Param[in]     reg         - PHY register to write
 @Param[in]     data        - Data to write in register.

 @Return        Always zero (success).
*//***************************************************************************/
int MII_WritePhyReg(t_Handle    h_MiiAccess,
                    uint8_t     phyAddr,
                    uint8_t     reg,
                    uint16_t    data);


#endif /* __MII_ACC_EXT_H */
