/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/*

 @File          qe_iw_ext.h

 @Description
*//***************************************************************************/

#ifndef __QE_IW_EXT_H
#define __QE_IW_EXT_H


#ifdef __cplusplus
extern "C"{
#endif

		/* INCLUDE FILES */

#include "error_ext.h"

#include "ucc_geth_ext.h"

#include "ucc_atm_common_ext.h"
#include "ucc_atm_ext.h"

#if (!defined(QE_IW_PPPOHT_UNAVAILABLE))
#include "iw_PPPOHT_ext.h"
#endif /* not QE_IW_PPPOHT_UNAVAILABLE */

#if (!defined(QE_IW_IPHC_UNAVAILABLE))
#include "iphc_ext.h"
#endif /* not QE_IW_IPHC_UNAVAILABLE */

#include "vp_ext.h"
#include "qe_filtering_ext.h"


		/* GLOBAL CONSTANTS */
/* Defines used for sizing the driver */
#define MAX_IW_CDESC_HMOP_PER_ENTRY_NUM 			5
#define AVG_IW_COMMON_REFCNT_HASH_COLLISIONS_NUM	4


		/* IW OBJECTS API */
#include "qe_iw_common_ext.h"
#include "qe_iw_dev_ext.h"
#include "qe_iw_cdesc_ext.h"
#include "qe_iw_conn_ext.h"
#include "qe_iw_mcast_ext.h"
#include "qe_iw_plcr_ext.h"
#include "qe_iw_qm_ext.h"

#if (!defined(QE_IW_IPREASS_CUSTOM_UNAVAILABLE) || !defined(QE_IW_IPREASS_FULL_UNAVAILABLE))
#include "qe_iw_ipreass_ext.h"
#endif  /* not QE_IW_IPREASS_CUSTOM_UNAVAILABLE || not QE_IW_IPREASS_FULL_UNAVAILABLE */

#if (!defined(QE_IW_IPSEC_UNAVAILABLE))
#include "qe_iw_ipsec_ext.h"
#endif /* not QE_IW_IPSEC_UNAVAILABLE */

#ifdef __cplusplus
}
#endif

#endif /* __QE_IW_EXT_H */
