/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**

 @File          e300_pm_asm_ext.h

 @Description   E300 asmbler external definitions prototypes
                This file is included by the E300 asm & C files.
                you must set INCLUDE_FROM_ASM when including in asm files
                This files defins BITS and function of CPU specific assmbler routines.
*//***************************************************************************/
#ifndef __E300_PM_ASM_EXT_H
#define __E300_PM_ASM_EXT_H

#ifndef INCLUDE_FROM_ASM
#include "std_ext.h"
#endif  /* INCLUDE_FROM_ASM */

/*
* PM Implementation-Specific PPRs
*
*/

#define E300_PM_PMC0            16      /* Performance monitor counter 0 */
#define E300_PM_PMC1            17      /* Performance monitor counter 1 */
#define E300_PM_PMC2            18      /* Performance monitor counter 2 */
#define E300_PM_PMC3            19      /* Performance monitor counter 3 */
#define E300_PM_PMLCa0          144     /* Performance monitor local control a0 */
#define E300_PM_PMLCa1          145     /* Performance monitor local control a1 */
#define E300_PM_PMLCa2          146     /* Performance monitor local control a2 */
#define E300_PM_PMLCa3          147     /* Performance monitor local control a3 */
#define E300_PM_PMGC0           400     /* Performance monitor global control 0 */

#define MSR_PMM                 0x4
#define not_MSR_PMM             0xFFFFFFFB

#ifndef INCLUDE_FROM_ASM

void  MSR_EnablePMM(void);
void  MSR_DisablePMM(void);


/* Performance Monitoring */
uint32_t E300_GetPMC0(void);
void E300_SetPMC0(uint32_t newvalue);
uint32_t E300_GetPMC1(void);
void E300_SetPMC1(uint32_t newvalue);
uint32_t E300_GetPMC2(void);
void E300_SetPMC2(uint32_t newvalue);
uint32_t E300_GetPMC3(void);
void E300_SetPMC3(uint32_t newvalue);
uint32_t E300_GetPMLCa0(void);
void E300_SetPMLCa0(uint32_t newvalue);
uint32_t E300_GetPMLCa1(void);
void E300_SetPMLCa1(uint32_t newvalue);
uint32_t E300_GetPMLCa2(void);
void E300_SetPMLCa2(uint32_t newvalue);
uint32_t E300_GetPMLCa3(void);
void E300_SetPMLCa3(uint32_t newvalue);
uint32_t E300_GetPMLCb0(void);
void E300_SetPMLCb0(uint32_t newvalue);
uint32_t E300_GetPMLCb1(void);
void E300_SetPMLCb1(uint32_t newvalue);
uint32_t E300_GetPMLCb2(void);
void E300_SetPMLCb2(uint32_t newvalue);
uint32_t E300_GetPMLCb3(void);
void E300_SetPMLCb3(uint32_t newvalue);
uint32_t E300_GetPMGC0 (void);
void E300_SetPMGC0 (uint32_t newvalue);


#endif /* INCLUDE_FROM_ASM */


#endif /* __E300_PM_ASM_EXT_H */
