/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
 /**************************************************************************//**

 @File          dma_std_ext.h

 @Description   DMA common definitions

 @Cautions      None.

*//***************************************************************************/
#ifndef __DMA_STD_EXT_H
#define __DMA_STD_EXT_H

/**************************************************************************//**
 @Group         dma_std_grp  Common DMA Application Programming Interface

 @Description   Prototypes, externals and typedefs for system-supplied
                (external) DMA Routines.
 @{
*//***************************************************************************/

/**************************************************************************//**
 @Description   DMA single transfer parameters
*//***************************************************************************/
typedef struct t_DmaTransferParam
{
    uint64_t    srcAddr;     /**< Source address of the transfer            */
    uint64_t    dstAddr;     /**< Target address of the transfer            */
    uint32_t    byteCount;   /**< Number of bytes to transfer               */
    bool        intrEnable;  /**< Enable interrupt upon transfer completion */
    bool        snoopEnable; /**< Enable snooping for the current transfer  */
} t_DmaTransferParam;

/** @} */ /* end of dma_std_grp */

#endif /* __DMA_STD_EXT_H */
