/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/

/**************************************************************************//**
 @File          i2c_std_ext.h

 @Description   I2C generic functions, definitions and enums.

*//***************************************************************************/

#ifndef __I2C_STD_EXT_H__
#define __I2C_STD_EXT_H__

/**************************************************************************//**
 @Description   I2C transaction mode, transmit/receive transaction.
*//***************************************************************************/
typedef enum e_I2cTransMode
{
    e_I2C_TRANS_TX_MODE,   /**< Transmit */
    e_I2C_TRANS_RX_MODE    /**< Receive  */
} e_I2cTransMode;


#define I2C_STD_MIN_VAL_7_BIT_ADDRESS     8             /**< Minimal value of 7 bit address */
#define I2C_STD_MAX_VAL_7_BIT_ADDRESS     120           /**< Max value of seven bit address */

#define I2C_STD_READ_BIT                  0x00000001    /**< Last bit in the address that indicates that
                                                             the address is for read operation */
#define I2C_STD_ADDRESS_SHIFT             1             /**< The shift of the address in order to set the
                                                             last bit as the direction - read or write */


#endif /* __I2C_STD_EXT_H__ */
