/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**

 @Description   QE BRG External Clock Source Options table.
 
                This table describes the legal CLK's for each BRG.
*//***************************************************************************/

#ifndef __QE_BRG_EXT_CLK_SRC_TABLE_H
#define __QE_BRG_EXT_CLK_SRC_TABLE_H

static uint8_t brgExtClkSrcTable[QE_NUM_OF_BRGS][QE_MAX_EXT_CLKS_FOR_BRG] =
{
    {e_QE_CLK3 , e_QE_CLK5 }, /* BRG1 */
    {e_QE_CLK3 , e_QE_CLK5 }, /* BRG2 */
    {e_QE_CLK9 , e_QE_CLK15}, /* BRG3 */
    {e_QE_CLK9 , e_QE_CLK15}, /* BRG4 */
    {e_QE_CLK3 , e_QE_CLK5 }, /* BRG5 */
    {e_QE_CLK3 , e_QE_CLK5 }, /* BRG6 */
    {e_QE_CLK9 , e_QE_CLK15}, /* BRG7 */
    {e_QE_CLK9 , e_QE_CLK15}, /* BRG8 */
    {e_QE_CLK11, e_QE_CLK21}, /* BRG9 */
    {e_QE_CLK11, e_QE_CLK21}, /* BRG10 */
    {e_QE_CLK13, e_QE_CLK23}, /* BRG11 */
    {e_QE_CLK13, e_QE_CLK23}, /* BRG12 */
    {e_QE_CLK11, e_QE_CLK21}, /* BRG13 */
    {e_QE_CLK11, e_QE_CLK21}, /* BRG14 */
    {e_QE_CLK13, e_QE_CLK23}, /* BRG15 */
    {e_QE_CLK13, e_QE_CLK23}, /* BRG16 */
};
#endif /* __QE_BRG_EXT_CLK_SRC_TABLE_H */
