/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**

 @Description   QE MUX Assignment table.
 
                This table describes the legal BRG's and clocks for each
                required signal. The location in the array (i.e. the index)
                describes the code used in the appropriate QE MUX register.
*//***************************************************************************/

#ifndef __QE_MUX_TABLE_H
#define __QE_MUX_TABLE_H


static uint8_t muxAssignmentsTable[QE_NUM_OF_CLK_SIGNALS][QE_NUM_OF_MUX_OPTIONS] =
{
{e_QE_CLK_SIGNAL_TDM1_A_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK3, e_QE_CLK8,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
 
{e_QE_CLK_SIGNAL_TDM1_A_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK4, e_QE_CLK9,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_B_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK5, e_QE_CLK10,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_B_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK6, e_QE_CLK11,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_C_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK7, e_QE_CLK12,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_C_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK8, e_QE_CLK13,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_D_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK9, e_QE_CLK14,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_D_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK1, e_QE_CLK2, e_QE_CLK10, e_QE_CLK15,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},

{e_QE_CLK_SIGNAL_TDM1_E_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK11, e_QE_CLK16,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_E_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK12, e_QE_CLK17,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_F_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK13, e_QE_CLK18,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_F_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK14, e_QE_CLK19,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_G_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK15, e_QE_CLK20,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_G_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK16, e_QE_CLK21,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_H_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK17, e_QE_CLK22,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_H_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK23, e_QE_CLK24, e_QE_CLK18, e_QE_CLK3,
                            e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},

{e_QE_CLK_SIGNAL_TDM1_A_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_A_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_B_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_B_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_C_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_C_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_D_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_D_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},

{e_QE_CLK_SIGNAL_TDM1_E_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_E_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_F_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_F_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_G_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_G_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_H_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM1_H_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},

{e_QE_CLK_SIGNAL_TDM2_A_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK2, e_QE_CLK7, e_QE_CLK8, e_QE_CLK9, e_QE_CLK14,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_A_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK2, e_QE_CLK14, e_QE_CLK16, e_QE_CLK17, e_QE_CLK25,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_B_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK2, e_QE_CLK13, e_QE_CLK14,e_QE_CLK21,e_QE_CLK25,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_B_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK2, e_QE_CLK4, e_QE_CLK14, e_QE_CLK24,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_C_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK2, e_QE_CLK5, e_QE_CLK14, e_QE_CLK15, e_QE_CLK21,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_C_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK2, e_QE_CLK11, e_QE_CLK14, e_QE_CLK16, e_QE_CLK24,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_D_RX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK2, e_QE_CLK14, e_QE_CLK16, e_QE_CLK18, e_QE_CLK26,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,},
{e_QE_CLK_SIGNAL_TDM2_D_TX,  e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK2, e_QE_CLK14, e_QE_CLK24, e_QE_CLK26,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_E_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK20, e_QE_CLK23, e_QE_CLK24, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_E_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK15, e_QE_CLK19, e_QE_CLK15, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_F_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK6, e_QE_CLK8, e_QE_CLK23, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_F_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK_NONE, e_QE_CLK7, e_QE_CLK18, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_G_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK7, e_QE_CLK10, e_QE_CLK20, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_G_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK1, e_QE_CLK5, e_QE_CLK17, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_H_RX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK4, e_QE_CLK21, e_QE_CLK22, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_H_TX,  e_QE_CLK_NONE, e_QE_BRG12, e_QE_BRG13, e_QE_CLK12, e_QE_CLK13, e_QE_CLK19, e_QE_CLK27, e_QE_CLK28,
                             e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},

{e_QE_CLK_SIGNAL_TDM2_A_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_A_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_B_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_B_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_C_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_C_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_D_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_D_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG11, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_E_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_E_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_F_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_F_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_G_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_G_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_H_RX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_TDM2_H_TX_SYNC, e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG15, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},

{e_QE_CLK_SIGNAL_UCC_1_RX,      e_QE_CLK_NONE, e_QE_BRG1, e_QE_BRG2, e_QE_BRG7, e_QE_BRG8, e_QE_CLK9, e_QE_CLK10, e_QE_CLK11,
                                e_QE_CLK12, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_1_TX,      e_QE_CLK_NONE, e_QE_BRG1, e_QE_BRG2, e_QE_BRG7, e_QE_BRG8, e_QE_CLK9, e_QE_CLK10, e_QE_CLK11,
                                e_QE_CLK12, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_2_RX,      e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_BRG15, e_QE_BRG16, e_QE_CLK3, e_QE_CLK4, e_QE_CLK17,
                                e_QE_CLK18, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_2_TX,      e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_BRG15, e_QE_BRG16, e_QE_CLK3, e_QE_CLK4, e_QE_CLK17,
                                e_QE_CLK18, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},

{e_QE_CLK_SIGNAL_UCC_3_RX,      e_QE_CLK_NONE, e_QE_BRG1, e_QE_BRG2, e_QE_BRG7, e_QE_BRG8, e_QE_CLK9, e_QE_CLK10, e_QE_CLK11,
                                e_QE_CLK12, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_3_TX,      e_QE_CLK_NONE, e_QE_BRG1, e_QE_BRG2, e_QE_BRG7, e_QE_BRG8, e_QE_CLK9, e_QE_CLK10, e_QE_CLK11,
                                e_QE_CLK12, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_4_RX,      e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_BRG15, e_QE_BRG16, e_QE_CLK3, e_QE_CLK4, e_QE_CLK17,
                                e_QE_CLK18, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_4_TX,      e_QE_CLK_NONE, e_QE_BRG9, e_QE_BRG10, e_QE_BRG15, e_QE_BRG16, e_QE_CLK3, e_QE_CLK4, e_QE_CLK17,
                                e_QE_CLK18, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_5_RX,      e_QE_CLK_NONE, e_QE_BRG5, e_QE_BRG6, e_QE_BRG7, e_QE_BRG8, e_QE_CLK13, e_QE_CLK14, e_QE_CLK19,
                                e_QE_CLK20, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_5_TX,      e_QE_CLK_NONE, e_QE_BRG5, e_QE_BRG6, e_QE_BRG7, e_QE_BRG8, e_QE_CLK13, e_QE_CLK14, e_QE_CLK19,
                                e_QE_CLK20, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_6_RX,      e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_BRG15, e_QE_BRG16, e_QE_CLK5, e_QE_CLK6, e_QE_CLK21,
                                e_QE_CLK22, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_6_TX,      e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_BRG15, e_QE_BRG16, e_QE_CLK5, e_QE_CLK6, e_QE_CLK21,
                                e_QE_CLK22, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_7_RX,      e_QE_CLK_NONE, e_QE_BRG5, e_QE_BRG6, e_QE_BRG7, e_QE_BRG8, e_QE_CLK13, e_QE_CLK14, e_QE_CLK19,
                                e_QE_CLK20, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_7_TX,      e_QE_CLK_NONE, e_QE_BRG5, e_QE_BRG6, e_QE_BRG7, e_QE_BRG8, e_QE_CLK13, e_QE_CLK14, e_QE_CLK19,
                                e_QE_CLK20, e_QE_CLK15, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_8_RX,      e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_BRG15, e_QE_BRG16, e_QE_CLK5, e_QE_CLK6, e_QE_CLK21,
                                e_QE_CLK22, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UCC_8_TX,      e_QE_CLK_NONE, e_QE_BRG13, e_QE_BRG14, e_QE_BRG15, e_QE_BRG16, e_QE_CLK5, e_QE_CLK6, e_QE_CLK21,
                                e_QE_CLK22, e_QE_CLK7, e_QE_CLK8, e_QE_CLK16, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UPC_1_RX,      e_QE_CLK_NONE, e_QE_BRG5, e_QE_BRG6, e_QE_BRG7, e_QE_BRG8, e_QE_CLK13, e_QE_CLK14, e_QE_CLK15,
                                e_QE_CLK16, e_QE_CLK19, e_QE_CLK20, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UPC_1_TX,      e_QE_CLK_NONE, e_QE_BRG5, e_QE_BRG6, e_QE_BRG7, e_QE_BRG8, e_QE_CLK13, e_QE_CLK14, e_QE_CLK15,
                                e_QE_CLK16, e_QE_CLK19, e_QE_CLK20, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_UPC_1_INT_RATE,e_QE_CLK_NONE, e_QE_BRG3, e_QE_BRG4, e_QE_CLK18, e_QE_CLK19, e_QE_CLK17, e_QE_CLK_NONE, e_QE_CLK_NONE,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_USB,           e_QE_CLK_NONE, e_QE_CLK3, e_QE_CLK5, e_QE_CLK7, e_QE_CLK9, e_QE_CLK13, e_QE_CLK17, e_QE_CLK19,
                                e_QE_CLK21, e_QE_BRG9, e_QE_BRG10, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE},
{e_QE_CLK_SIGNAL_RTC,           e_QE_CLK_EXT_RTC, e_QE_BRG3, e_QE_BRG4, e_QE_CLK_NONE, e_QE_CLK7, e_QE_CLK8, e_QE_CLK15, e_QE_CLK16,
                                e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE, e_QE_CLK_NONE}
};
#endif /* __QE_MUX_TABLE_H */
