/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**

 @Description   IPIC sources table.
 
                This table provides integration-specific information on
                all IPIC sources.
*//***************************************************************************/

#ifndef __QE_IC_SOURCES_TABLE_H
#define __QE_IC_SOURCES_TABLE_H

/* QE IC mask registers */
#define QE_CIMR_UCC1        0x80000000
#define QE_CIMR_UCC3        0x20000000
#define QE_CIMR_UCC5        0x00800000
#define QE_CIMR_UCC7        0x00200000
#define QE_CIMR_SPI         0x00004000
#define QE_CIMR_RTT         0x00002000
#define QE_CIMR_SDMA        0x00000040
#define QE_CIMR_USB         0x00000020
#define QE_CIMR_TIMER1      0x00000010
#define QE_CIMR_TIMER2      0x00000008
#define QE_CIMR_TIMER3      0x00000004
#define QE_CIMR_TIMER4      0x00000002

#define QE_CRIMR_PTP        0x80000000
#define QE_CRIMR_VT         0x10000000
#define QE_CRIMR_PTP_RTC    0x08000000
#define QE_CRIMR_EXT1       0x00800000
#define QE_CRIMR_EXT2       0x00400000
#define QE_CRIMR_EXT3       0x00200000
#define QE_CRIMR_EXT4       0x00100000


static t_QeIcSrcInfo qeIcSourcesTable[] =
{
    /* intrSrc                  sysMask     mask                priCode  */
    { e_QE_IC_INTR_SPI,         TRUE,       QE_CIMR_SPI,        1 },
    { e_QE_IC_INTR_RTT,         TRUE,       QE_CIMR_RTT,        2 },
    { e_QE_IC_INTR_SDMA,        TRUE,       QE_CIMR_SDMA,       1 },
    { e_QE_IC_INTR_USB,         TRUE,       QE_CIMR_USB,        2 },
    { e_QE_IC_INTR_TIMER_1,     TRUE,       QE_CIMR_TIMER1,     3 },
    { e_QE_IC_INTR_TIMER_2,     TRUE,       QE_CIMR_TIMER2,     4 },
    { e_QE_IC_INTR_TIMER_3,     TRUE,       QE_CIMR_TIMER3,     5 },
    { e_QE_IC_INTR_TIMER_4,     TRUE,       QE_CIMR_TIMER4,     6 },
    { e_QE_IC_INTR_PTP,         FALSE,      QE_CRIMR_PTP,       0 },
    { e_QE_IC_INTR_VT,          FALSE,      QE_CRIMR_VT,        3 },
    { e_QE_IC_INTR_RTC,         FALSE,      QE_CRIMR_PTP_RTC,   4 },
    { e_QE_IC_INTR_EXT_REQ_1,   FALSE,      QE_CRIMR_EXT1,      0 },
    { e_QE_IC_INTR_EXT_REQ_2,   FALSE,      QE_CRIMR_EXT2,      1 },
    { e_QE_IC_INTR_EXT_REQ_3,   FALSE,      QE_CRIMR_EXT3,      2 },
    { e_QE_IC_INTR_EXT_REQ_4,   FALSE,      QE_CRIMR_EXT4,      3 },
    { e_QE_IC_INTR_UCC_1,       TRUE,       QE_CIMR_UCC1,       0 },
    { e_QE_IC_INTR_UCC_3,       TRUE,       QE_CIMR_UCC3,       2 },
    { e_QE_IC_INTR_UCC_5,       TRUE,       QE_CIMR_UCC5,       0 },
    { e_QE_IC_INTR_UCC_7,       TRUE,       QE_CIMR_UCC7,       2 }
};


#endif /* __QE_IC_SOURCES_TABLE_H */

