/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**
 @File          xx_integration_ext.h

 @Description   Inline optimizations for the XX interface (bare-board only)
*//***************************************************************************/

#ifndef __XX_INTEGRATION_EXT_H
#define __XX_INTEGRATION_EXT_H

#include "std_ext.h"


/*****************************************************************************/
static __inline__ uint32_t XX_DisableAllIntr(void)
{
    uint32_t   temp = 0 ;

#if !defined (__QNXNTO__) || !defined(QNX_NO_DISABLE_ALL_INTR)
    __asm__ (".cpu e500;mfmsr   %0" : "=r" (temp));
    __asm__ (".cpu e500;wrteei   0"); //Disable interrupt
#endif

    return temp;
}

/*****************************************************************************/
static __inline__ void XX_RestoreAllIntr(uint32_t flags)
{
#if !defined (__QNXNTO__) || !defined(QNX_NO_DISABLE_ALL_INTR)
    __asm__ (".cpu e500;wrtee   %0" : : "r" (flags)); //Enable interrupt by flags
#endif
}


#endif /* __XX_INTEGRATION_EXT_H */
