/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __UTOPIA_POS_EXT_H
#define __UTOPIA_POS_EXT_H


/**************************************************************************//**
 @Group         utopia_pos_grp General UTOPIA/POS Interface Definitions

 @Description   General definitions and enumerations for UTOPIA/POS
                physical interface.

 @{
*//***************************************************************************/

/**************************************************************************//**
 @Description   UTOPIA/POS Protocols
*//***************************************************************************/
typedef enum e_UtopiaPosProtocol
{
    e_UTOPIA_PROTOCOL,  /**< UTOPIA protocol */
    e_POS_PHY_PROTOCOL  /**< POS-PHY protocol */
} e_UtopiaPosProtocol;


/**************************************************************************//**
 @Description   UTOPIA/POS Bus Widths
*//***************************************************************************/
typedef enum e_UtopiaPosBusWidth
{
    e_UTOPIA_POS_BUS_WIDTH_8,   /**< 8-bit bus width */
    e_UTOPIA_POS_BUS_WIDTH_16   /**< 16-bit bus width */
} e_UtopiaPosBusWidth;


/**************************************************************************//**
 @Description   UTOPIA/POS PHY Device Modes
*//***************************************************************************/
typedef enum e_UtopiaPosDevMode
{
    e_UTOPIA_POS_DEV_MODE_SPHY, /**< Single-PHY mode */
    e_UTOPIA_POS_DEV_MODE_MPHY  /**< Multi-PHY mode */
} e_UtopiaPosDevMode;


/** @} */ /* end of utopia_pos_grp */


#endif /* __UTOPIA_POS_EXT_H */
