/******************************************************************************

 Copyright  1995-2009 Freescale Semiconductor Inc.

 All Rights Reserved



 **************************************************************************/
#ifndef __SYS_TIMER_EXT_H
#define __SYS_TIMER_EXT_H

#include "std_ext.h"
#include "timer_ext.h"
#include "sys_ext.h"


/**************************************************************************//**
 @Group         sys_grp     System Interfaces

 @Description   Bare-board system programming interfaces.

 @{
*//***************************************************************************/
/**************************************************************************//**
 @Group         sys_timer_grp   System Timer Service

 @Description   Bare-board system interface for timer operations.

 @{
*//***************************************************************************/


/**************************************************************************//**
 @Function      SYS_RegisterTimer

 @Description   Register a physical timer as the system timer.

 @Param[in]     p_TimerOps      - Pointer to the timer interface structure.
 @Param[in]     allowUserTimers - TRUE to allow user-owned timers;
                                  FALSE to permit only system-owned timers.

 @Return        E_OK on success; Error code otherwise.
*//***************************************************************************/
t_Error SYS_RegisterTimer(t_TimerOps *p_TimerOps, bool allowUserTimers);

/**************************************************************************//**
 @Function      SYS_UnregisterTimer

 @Description   Unregister the system timer.

 @Param[in]     h_Timer - The handle to the timer object, as was provided in
                          the \c p_TimerOps parameter of SYS_RegisterTimer().

 @Return        E_OK on success; Error code otherwise.
*//***************************************************************************/
t_Error SYS_UnregisterTimer(t_Handle h_Timer);


/** @} */ /* end of sys_timer_grp */
/** @} */ /* end of sys_grp */


#endif /* __SYS_TIMER_EXT_H */
