/* 
Derived from bare/xx/integrations/P4080/xx_integration.c. 
Original freescale license below
*/

/******************************************************************************

 Copyright  1995-2009 Freescale Semiconductor Inc.

 All Rights Reserved



 **************************************************************************/

#include "std_ext.h"
#include "string_ext.h"
#include "error_ext.h"
#include "xx_ext.h"
#include <unistd.h>

#if !defined(__QNXNTO__)
#include "timer_ext.h"
#include "tasklet_ext.h"
#include "e500v2_asm_ext.h"
#include "sys_ext.h"
#endif /* __QNXNTO */

#define __ERR_MODULE__ MODULE_UNKNOWN


/*****************************************************************************/
uint32_t XX_DisableAllIntr(void)
{
    uint32_t   temp = 0 ;
#if !defined (__QNXNTO__) || !defined(QNX_NO_DISABLE_ALL_INTR)
    __asm__ (".cpu e500; mfmsr   %0" : "=r" (temp));
    __asm__ (".cpu e500;wrteei   0"); /* Disable external-interrupt */
#endif
    return temp;
}

/*****************************************************************************/
void XX_RestoreAllIntr(uint32_t flags)
{
#if !defined (__QNXNTO__) || !defined(QNX_NO_DISABLE_ALL_INTR)
    __asm__ (".cpu e500; wrtee   %0" : : "r" (flags)); /*Enable interrupt by flags*/
#endif
}


typedef struct
{
    volatile int done;
} t_Timeout;

/*BEWARE!!!!! XX_Sleep routine is enabling interrupts!!!!!*/
/*****************************************************************************/
uint32_t XX_Sleep(uint32_t msecs)
{
	return (uint32_t)usleep(msecs*1000);
}



