/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __VSC_8641_EXT_H
#define __VSC_8641_EXT_H

// Also compatible with Vitesse 8601


#include "std_ext.h"
#include "enet_ext.h"
#include "mii_mng_ext.h"


t_Error VSC8641_Init(   uint8_t           phyAddr,
                        e_EnetMode        ethMode,
                        bool              autoNegotiation,
                        e_EnetDuplexMode  duplexMode,
                        e_DiagMode        loopbackMode,
                        t_Handle          h_MiiAccess,
                        t_MiiPhyWriteFunc *f_SetPhyReg,
                        t_MiiPhyReadFunc  *f_GetPhyReg);



// Register Id. for the Cicada (8641) Phy.
#define MII_8641_ModeControl                 0
#define MII_8641_ModeStatus                  1
#define MII_8641_PHY_IdReg1                  2
#define MII_8641_PHY_IdReg2                  3
#define MII_8641_AutoNegAdvert               4
#define MII_8641_AutoNegLinkPartnerAbility   5
#define MII_8641_AutoNegExpansion            6
#define MII_8641_AutoNegNextPageTx           7
#define MII_8641_AutoNegLinkPartnerNextPage  8
#define MII_8641_1000BaseTControl            9
#define MII_8641_1000BaseTStatus            10
#define MII_8641_1000BaseTStatusExt1        15
#define MII_8641_1000BaseTStatusExt         16
#define MII_8641_1000BaseTStatusExt2        17
#define MII_8641_BypassControl              18
#define MII_8641_ReceiveErrorCounter        19
#define MII_8641_FalseCarrierSenseCnt       20
#define MII_8641_DisconnectCnt              21
#define MII_8641_10BaseControlAndStatus     22
#define MII_8641_ExtendedPHYCont1           23
#define MII_8641_ExtendedPHYCont2           24
#define MII_8641_InterruptMask              25
#define MII_8641_InterruptStatus            26
#define MII_8641_ParalelLedCont             27
#define MII_8641_AuxControlAndStatus        28
#define MII_8641_DelaySkewStatus            29


// MII_8641_ModeControl - Bit Mode Control Register
#define BMCR_RESET              0x8000
#define BMCR_LOOPBACK           0x4000
#define BMCR_SPEED_SELECT       0x2000
#define BMCR_AUTO_NEG_ENABLE    0x1000
#define BMCR_ISOLATE            0x0400
#define BMCR_FULL_DUPLEX        0x0100

#define BMCR_SPEED_SELECT_H     0x0040
#define BMCR_SPEED_SELECT_L     0x2000
#define BMCR_SPEED_SELECT_MASK  0x2040
#define BMCR_AUTO_NEG_RESTART   0x0200

#define BMSR_AUTO_NEG_COMPLETED 0x0020
#define BMSR_LINK_STATUS        0x0004

#define DSCR_RMII_ENABLR        0x0100

#define EPHYCR_MAC_MODE_SEL_MASK         0xF000
#define EPHYCR_MAC_MODE_SEL_GMII_MII_VAL 0x00
#define EPHYCR_MAC_MODE_SEL_RGMII_VAL    0x01
#define EPHYCR_MAC_MODE_SEL_TBI_VAL      0x02
#define EPHYCR_MAC_MODE_SEL_RTBI_VAL     0x03

#define EPHYCR_MAC_IF_DIO_PS_MASK        0x0E00
#define EPHYCR_MAC_IF_DIO_PS_33_VAL      0
#define EPHYCR_MAC_IF_DIO_PS_25_VAL      1

#define EPHYCR_RGMII_SKEW_ENABLE_MASK    0x0100

#define EPHYCR_EWRAP_ENABLE_MASK         0x0080

#define EPHYCR_TBI_BIT_ORDER_REV_EN_MASK 0x0040

#define EPHYCR_ACTPHY_TX_PIN_REV_MASK    0x0020

#define EPHYCR_GMII_TX_PIN_REV_MASK      0x0002

#define AUX_CONT_STAT_REG_ANEG_MASK      0xC000
#define AUX_CONT_STAT_REG_ANEG_ENABLED   0x4000
#define AUX_CONT_STAT_REG_ANEG_COMPLETED 0x8000


#define RC_GET_ENET_LINK_STAT_OK         0
#define RC_GET_ENET_LINK_STAT_DIS_ANEG   -1

#endif // __VSC_8641_EXT_H
