/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __TN2020_H
#define __TN2020_H

#include "error_ext.h"
#include "std_ext.h"
#include "enet_ext.h"
#include "xx_ext.h"

/* MDIO Manageable Device */
#define MDD_PMA_PMD           1
#define MDD_PCS               3
#define MDD_PHY_XS            4
#define MDD_AN                7
#define MDD_VENDOR_SPECIFIC_1 30
#define MDD_VENDOR_SPECIFIC_2 31

/* COMMON REGISTERS */
#define MDD_CR              0x00    /* Control Register */
#define MDD_SR              0x01    /* Status Register */
#define MDD_IDR_1           0x02    /* Identifier Register 1*/
#define MDD_IDR_2           0x03    /* Identifier Register 2*/


/* MDD AN Control Register (section 5.5.1) */
#define MDD_AN_CR_RESET         0x8000  /* Reset */
#define MDD_AN_CR_ENP           0x2000  /* ENP Ability */
#define MDD_AN_CR_AN_ENABLE     0x1000  /* Auto-negotiation enable */
#define MDD_AN_CR_AN_RESTART    0x0200  /* Restart auto-negotiation */

/* MDD AN Status Register (section 5.5.1) */
#define MDD_AN_SR_RESET         0x8000  /* Reset */
#define MDD_AN_SR_ENP           0x2000  /* ENP Ability */
#define MDD_AN_SR_AN_ENABLE     0x1000  /* Auto-negotiation enable */
#define MDD_AN_SR_LINK          0x0004  /* Link status */

#endif /* __TN2020_H */
