/******************************************************************************

 © 1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#include "error_ext.h"
#include "std_ext.h"
#include "enet_ext.h"
#include "xx_ext.h"

#include "vsc7385_ext.h"
#include "vsc7385_fw.h"

#define __ERR_MODULE__ MODULE_UNKNOWN

#define VSC7385_READ(addr)        GET_UINT32(*(uint32_t*)(addr))
#define VSC7385_WRITE(addr,value) WRITE_UINT32(*(uint32_t*)(addr),(uint8_t)(value))

t_Error VSC7385_Init(uint32_t baseAddress)
{
    uint32_t tmp, i;
    uint32_t gloreset     = (baseAddress + 0x1c050);
	uint32_t icpu_ctrl    = (baseAddress + 0x1c040);
	uint32_t icpu_addr    = (baseAddress + 0x1c044);
	uint32_t icpu_data    = (baseAddress + 0x1c048);
	uint32_t icpu_rom_map = (baseAddress + 0x1c070);
   

    XX_UDelay(200000);

	VSC7385_WRITE(gloreset, 3);

 	XX_UDelay(200);

	VSC7385_WRITE(icpu_ctrl, 0x8E);

	XX_UDelay(20);

	VSC7385_WRITE(icpu_rom_map, 1);
	XX_UDelay(20);

	/* Write the firmware to I-RAM */
	VSC7385_WRITE(icpu_addr, 0);
	XX_UDelay(20);

	for (i = 0; i < VSC_7385_FW_SIZE; i++) {
		VSC7385_WRITE(icpu_data, vsc7385_Firmware[i]);
		XX_UDelay(20);
	}

	/* Read back and compare */
	VSC7385_WRITE(icpu_addr, 0);
	XX_UDelay(20);

	for (i = 0; i < VSC_7385_FW_SIZE; i++)
	{
		tmp = (uint8_t) VSC7385_READ(icpu_data);
		XX_UDelay(20);
		if (tmp != vsc7385_Firmware[i]) {
			XX_Print("VSC7385: Upload mismatch: address 0x%x, "
			      "read value 0x%x, image value 0x%x\n",
			      i, tmp, vsc7385_Firmware[i]);
			return E_WRITE_FAILED;
		}
	}

// needs further clarification

	VSC7385_WRITE(icpu_ctrl, 0x0B);
	XX_UDelay(20);

    return E_OK;
}


bool VSC7385_GetEthernetLinkStatus(uint32_t baseAddress)
{

    UNUSED(baseAddress);

// needs further clarification

	return TRUE;
}


