/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __VSC82X4_H
#define __VSC82X4_H

#include "error_ext.h"
#include "std_ext.h"
#include "enet_ext.h"
#include "xx_ext.h"

// Register Id. for the vitesse (82X4) Phy.
#define MII_82X4_ModeControl                 0
#define MII_82X4_ModeStatus                  1
#define MII_82X4_PHY_IdReg1                  2
#define MII_82X4_PHY_IdReg2                  3
#define MII_82X4_AutoNegAdvert               4
#define MII_82X4_AutoNegLinkPartnerAbility   5
#define MII_82X4_AutoNegExpansion            6
#define MII_82X4_AutoNegNextPageTx           7
#define MII_82X4_AutoNegLinkPartnerNextPage  8
#define MII_82X4_1000BaseTControl            9
#define MII_82X4_1000BaseTStatus            10
#define MII_82X4_1000BaseTStatusExt1        15
#define MII_82X4_1000BaseTStatusExt         16
#define MII_82X4_1000BaseTStatusExt2        17
#define MII_82X4_BypassControl              18
#define MII_82X4_ExtendedControlAndStatus   22
#define MII_82X4_ExtendedPHYCont1           23
#define MII_82X4_ExtendedPHYCont2           24
#define MII_82X4_InterruptMask              25
#define MII_82X4_InterruptStatus            26
#define MII_82X4_ParalelLedCont             27
#define MII_82X4_AuxControlAndStatus        28

// MII_82X4_ModeControl - Bit Mode Control Register
#define BMCR_RESET                          0x8000
#define BMCR_LOOPBACK                       0x4000
#define BMCR_SPEED_SELECT_100               0x2000
#define BMCR_SPEED_SELECT_1000              0x0040
#define BMCR_AUTO_NEG_ENABLE                0x1000
#define BMCR_FULL_DUPLEX                    0x0100

// MII_82X4_ModeStatus - Bit Mode Status Register
#define BMSR_AUTO_NEG_COMPLETED             0x0020
#define BMSR_LINK_STATUS                    0x0004

// MII_82X4_1000BaseTControl - Bit 1000 BaseT Control Register
#define BBCR_MASTER_CONFIG_ENABLE           0x1000
#define BBCR_MASTER_CONFIG_VALUE            0x0800

#endif /* __VSC82X4_H */
