/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**
 @File          cli_ext.h

 @Description   Command Line Interface module API
*//***************************************************************************/
#ifndef __CLI_EXT_H
#define __CLI_EXT_H

#include "std_ext.h"
#include "error_ext.h"


/* CLI attributes options */
#define CLI_ATT_BLOCKING    0x80000000


typedef struct t_CliCommandParam
{
    char        *name;
    char        *desc;
    char        *format;
    t_Handle    h_CommArg;
    t_Error     (*f_DoCommand)(t_Handle h_CommArg, int argc, char *argv[]);
} t_CliCommandParam;

typedef struct t_CliParam
{
    char        *prompt;
    uint32_t    attributes;
    void        (*f_Print)(char *str, ...);
    char        (*f_GetChar) (void);
} t_CliParam;


t_Handle CLI_ConfigAndInit(t_CliParam *p_CliParam);
t_Error  CLI_Free(t_Handle h_Cli);

t_Error  CLI_RegisterCommand(t_Handle h_Cli, t_CliCommandParam *p_CliCommandParam);
t_Error CLI_UnregisterCommand(t_Handle h_Cli, char *name);

t_Error  CLI_Run(t_Handle h_Cli);
t_Error  CLI_Stop(t_Handle h_Cli);

void     CLI_Print(t_Handle h_Cli, char *str, ...);
char     CLI_GetChar(t_Handle h_Cli);


#endif /* __CLI_EXT_H */
