/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**
  @File          pg.h

  @Description   Packet Generator Common Structures And Definitions
*//***************************************************************************/

#ifndef __PG_H
#define __PG_H

#include "error_ext.h"
#include "std_ext.h"
#include "list_ext.h"
#include "pg_ext.h"

/**************************************************************************//**
 @Description       Macros
*//***************************************************************************/
#define PG_FRAME_OBJECT(ptr)            LIST_OBJECT(ptr, t_PgFrame, frmsNode)

typedef struct {
    t_Handle                        h_FrameSettings;            /**< Frame settings */
    t_BufMemAccess                  bufMemAccess;               /**< Buffers memory access parameters */
    t_Handle                        h_TrafficIphc;              /**< Handle to pool of compressors */
} t_PacketGen;

typedef struct {
    t_PacketGen                     *p_PacketGen;               /**< Pointer to Packet Gen */
    t_List                          *p_List;                    /**< Pointer to the List created using the h_FrameSettings */
    uint32_t                        numOfFrameListSubSet;       /**< Number of frame descriptors (id-weight pair) */
    uint32_t                        *p_PgFrameWeights;          /**< Pointer to weight settings */

} t_PgListSettings;

#endif /* ____PG_H */

