/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
#ifndef __STOP_WATCH
#define __STOP_WATCH

#include "stop_watch_ext.h"

#define MAX_NUM_OF_SECTIONS 20

/* hidden globals */
typedef struct t_StwSectionTimer{
    char    *name;
    uint64_t  sumTime;
    uint64_t  minTime;
    uint64_t  maxTime;
    uint32_t  numTime;
    uint64_t  time;
    uint64_t  sumPause;
    uint64_t  minPause;
    uint64_t  maxPause;
    uint32_t  numPause;
    uint64_t  pause;

    uint32_t  lastTimer;
} t_StwSectionTimer;

typedef struct t_Stw
{
    uint64_t (*f_GetTime)( t_Handle h_TimeClk );
    t_Handle h_TimeClk;
    t_StwSectionTimer *p_StwSectionTimers[MAX_NUM_OF_SECTIONS];
    uint32_t currentTimer;
    uint32_t globalTimer;
}t_Stw;

#endif /* __STOP_WATCH */
