ifndef QCONFIG
QCONFIG=qconfig.mk
endif
include $(QCONFIG)
INSTALLDIR=usr/lib

NETCOMM_ROOT=$(PROJECT_ROOT)/NetCommSw
#PRE_INSTALL="$(PROJECT_ROOT)/cp_public_headers.sh"

NETCOMM_FMROOT=$(NETCOMM_ROOT)/Peripherals/FM
NETCOMM_BMROOT=$(NETCOMM_ROOT)/Peripherals/BM
NETCOMM_QMROOT=$(NETCOMM_ROOT)/Peripherals/QM
NETCOMM_DPAAROOT=$(NETCOMM_ROOT)/Peripherals/DPAA

NETCOMM_OSROOT=$(NETCOMM_ROOT)/user/env/qnx

EXTRA_SRCVPATH+=$(NETCOMM_ROOT)/ \
            $(NETCOMM_ROOT)/etc \
            $(NETCOMM_ROOT)/user/util/frame \
            $(NETCOMM_FMROOT)/ \
            $(NETCOMM_FMROOT)/HC \
            $(NETCOMM_FMROOT)/Pcd \
            $(NETCOMM_FMROOT)/MAC \
            $(NETCOMM_FMROOT)/Rtc \
            $(NETCOMM_FMROOT)/Port \
			$(NETCOMM_ROOT)/Peripherals/IoPort \
			$(NETCOMM_ROOT)/Peripherals/GPIO \
			$(NETCOMM_ROOT)/user/hardware/phys/Vitesse \
			$(NETCOMM_ROOT)/user/hardware/phys/Teranetics \
			$(NETCOMM_ROOT)/user/hardware \
			$(NETCOMM_ROOT)/user/hardware/boards \
			$(NETCOMM_ROOT)/user/hardware/boards/P4080DS \
            $(NETCOMM_DPAAROOT) \
			$(NETCOMM_ROOT)/integrations/P4080 \
			$(NETCOMM_ROOT)/cores/e500

EXTRA_SRCVPATH+=$(NETCOMM_BMROOT) 
EXTRA_SRCVPATH+=$(NETCOMM_QMROOT) 

#EXTRA_SRCVPATH+=$(PROJECT_ROOT)/sys-al

EXTRA_SRCVPATH+= $(NETCOMM_OSROOT)/xx \
				$(NETCOMM_OSROOT)/xx/integrations/P4080 

EXTRA_SRCVPATH+=$(NETCOMM_OSROOT)/services/DataPoolManager 

#EXTRA_SRCVPATH+=$(NETCOMM_OSROOT)/UseCases \
#				$(NETCOMM_OSROOT)/UseCases/common \
#			$(NETCOMM_OSROOT)/UseCases/integrations/P4080/FM \
#				$(NETCOMM_OSROOT)/services/DataPoolManager \
#				$(NETCOMM_OSROOT)/system/platform \
#				$(NETCOMM_OSROOT)/system 


EXTRA_INCVPATH+= $(PROJECT_ROOT)/inc \
            $(PROJECT_ROOT)/../../include \
            $(NETCOMM_ROOT)/user/inc \
            $(NETCOMM_ROOT)/user/hardware/inc \
            $(NETCOMM_ROOT)/inc \
            $(NETCOMM_ROOT)/inc/cores \
            $(NETCOMM_ROOT)/inc/etc \
            $(NETCOMM_ROOT)/inc/integrations \
            $(NETCOMM_ROOT)/inc/integrations/P4080/ \
            $(NETCOMM_ROOT)/inc/Peripherals \
            $(NETCOMM_FMROOT)/inc/ 

EXTRA_INCVPATH+= $(NETCOMM_OSROOT)/inc \
				$(NETCOMM_OSROOT)/inc/services

EXTRA_INCVPATH+= $(NETCOMM_OSROOT)/inc \
				$(NETCOMM_OSROOT)/inc/system \
				$(NETCOMM_OSROOT)/inc/wrappers/Peripherals/FM \
				$(NETCOMM_OSROOT)/inc/wrappers/Peripherals \
				$(NETCOMM_OSROOT)/inc/ioctl/Peripherals \
				$(NETCOMM_OSROOT)/UseCases/integrations/P4080/FM \
				$(NETCOMM_OSROOT)/UseCases/common/settings

EXCLUDE_OBJS=fm_guest.o vsc8201.o bm_guest.o qm_guest.o e500_intr_asm.o e500_asm.o

#NAME = $(PROJECT)S
NAME = NetCommSw
#Don't disable NO_OF_SUPPORT for QNX

ASFLAGS += -Wl,-E

CCFLAGS+=-DNO_OF_SUPPORT -DNCSW_PPC_CORE -DDISABLE_UNUSED_CODE
CCFLAGS+=-DP4080 -DNCSW_QNX 
CCFLAGS+=-DLOG_BMAN_BUF_ADDR 

ASFLAGS+=-Wa,-me500x2

CCFLAGS+=-DDEBUG_ERRORS=1 -DREPORT_EVENTS=1
CCFLAGS+=-DDEBUG_GLOBAL_LEVEL=4
CCFLAGS+=-DERROR_GLOBAL_LEVEL=2
CCFLAGS+=-DEVENT_GLOBAL_LEVEL=2
CCFLAGS+=-DDISABLE_SANITY_CHECKS -DDISABLE_ASSERTIONS
CCFLAGS+=-O3
#CCFLAGS+=-O0
CCFLAGS+=-Wno-strict-aliasing
#CCFLAGS+=-g
include $(MKFILES_ROOT)/qtargets.mk
#####AUTO-GENERATED by packaging script... do not checkin#####
   INSTALL_ROOT_nto = $(PROJECT_ROOT)/../../../../install
   USE_INSTALL_ROOT=1
##############################################################

