/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**

 @File          bcsr_mng_ext.h

 @Description   Prototypes, externals and typedefs for the BCSR manager module.
*//***************************************************************************/
#ifndef __BCSR_MNG_EXT_H
#define __BCSR_MNG_EXT_H

#include "std_ext.h"


typedef struct t_BcsrMngParam
{
    uint32_t    bcsrBaseAddr;
    uint8_t     numOfBcsrRegs;
    uint8_t     *p_MaxUsersPerBcsrReg;

} t_BcsrMngParam;


typedef enum e_BcsrOperation
{
    e_BCSR_OP_SET_AND_LOCK,
    e_BCSR_OP_SET_AND_UNLOCK,
    e_BCSR_OP_UNLOCK

} e_BcsrOperation;


typedef struct t_BcsrRequest
{
    uint8_t reg;
    uint8_t value;
    uint8_t mask;

} t_BcsrRequest;


t_Handle BCSR_ConfigAndInit(t_BcsrMngParam *p_BcsrMngParam);

t_Error BCSR_Free(t_Handle h_BcsrMng);

t_Error BCSR_IssueRequests(t_Handle         h_BcsrMng,
                           e_BcsrOperation  operation,
                           uint8_t          numOfRequests,
                           t_BcsrRequest    *p_Requests);



#endif /* __BCSR_MNG_EXT_H */
