/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//*

 @File          regsolver_ext.h

 @Description   External prototypes for the Register Solver module.
*//***************************************************************************/

#ifndef __REGSOLVER_EXT_H
#define __REGSOLVER_EXT_H


#include "std_ext.h"


/**************************************************************************//**
 @Group         etc_id   Utility Library Application Programming Interface

 @Description   External routines.

 @{
*//***************************************************************************/

/**************************************************************************//**
 @Group         regsolver_id Register Solver

 @Description   Register Solver Application Programming Interface.

 @{
*//***************************************************************************/

/**************************************************************************//**
 @Function      REGSOLVER_New

 @Description   Allocates and initializes a new Register Solver object.

 @Param[in]     maxUserCount - Maximum number of users per resource.

 @Return        Handle to the new object on success; NULL on failure.
*//***************************************************************************/
t_Handle REGSOLVER_New(uint8_t maxUserCount, uint32_t resetValue);

/**************************************************************************//**
 @Function      REGSOLVER_Delete

 @Description   Deletes a Register Solver object.

 @Param[in]     h_RegSolver - Handle to the Register Solver object.

 @Return        E_OK on success; Error code otherwise.
*//***************************************************************************/
t_Error REGSOLVER_Delete(t_Handle h_RegSolver);


uint32_t REGSOLVER_GetValue(t_Handle h_RegSolver);


bool REGSOLVER_LockBits(t_Handle h_RegSolver, uint32_t value, uint32_t mask);

bool REGSOLVER_UnlockBits(t_Handle h_RegSolver, uint32_t mask);

bool REGSOLVER_CheckLock(t_Handle h_RegSolver, uint32_t mask);


/** @} */ /* end of regsolver_id group */
/** @} */ /* end of etc_id group */


#endif /* __REGSOLVER_EXT_H */
