/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**

 @File          part_ext.h

 @Description   Definitions for the part (integration) module.
*//***************************************************************************/

#ifndef __PART_EXT_H
#define __PART_EXT_H

#include "std_ext.h"
#include "part_integration_ext.h"


#if !(defined(MPC836x) || defined(MPC8569) || defined(P1020) || defined(P1021) || defined(P1022) || defined(P4080))
#error "unable to proceed without chip-definition"
#endif /* !(defined(MPC834x) || ... */


/**************************************************************************//**
 @Description   Part callback typedef for revision information.

 @Param         appId   - (In) user's id as passed at init routine
 @Param         event   - (In) GPIO event register - may be used if a single routine
                        is passed to all events. Otherwize - redundent.

*//***************************************************************************/
typedef uint32_t (t_RevInfoCallback)(t_Handle h_Part);

/**************************************************************************//*
 @Description   Part data structure - must be contained in any integration
                data structure.
*//***************************************************************************/
typedef struct t_Part
{
    uint32_t    (* f_GetRevInfo)(t_Handle h_Part);
                /**< Returns the revision number of the chip. */
    uint64_t    (* f_GetModuleBase)(t_Handle h_Part, e_ModuleId moduleId);
                /**< Returns the address of the module's memory map base. */
    e_ModuleId  (* f_GetModuleIdByBase)(t_Handle h_Part, uint64_t baseAddress);
                /**< Returns the module's ID according to its memory map base. */
} t_Part;


#endif /* __PART_EXT_H */
