/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**

 @File          pm5384_ext.h

 @Description   PM5384 QUAD/PHYs external structures and definitions.
*//***************************************************************************/
#ifndef __PM5384_EXT_H
#define __PM5384_EXT_H


#include "std_ext.h"
#include "utopia_pos_ext.h"
#include "carrier_ext.h"


bool PM5384_IsConnected(uint32_t baseAddr);


void PM5384_EnableQuad(uint32_t             baseAddr,
                       uint8_t              numOfDevs,
                       uint8_t              numOfPhys,
                       e_LineRate           lineRate,
                       e_UtopiaPosProtocol  protocol,
                       e_UtopiaPosDevMode   allDevsOpMode,
                       e_UtopiaPosBusWidth  allDevsBusWidth);


void PM5384_DisableQuad(uint32_t baseAddr);


void PM5384_EnablePhy(uint32_t              baseAddr,
                      uint8_t               phyId,
                      uint8_t               phyAddr,
                      e_DiagMode            diagMode,
                      e_UtopiaPosProtocol   protocol,
                      e_UtopiaPosDevMode    allDevsOpMode,
                      e_UtopiaPosBusWidth   allDevsBusWidth);


void PM5384_DisablePhy(uint32_t baseAddr,uint8_t phyId);


typedef struct
{
    uint32_t txByteCount        ; /**< Tx byte count          */
    uint32_t txFrameCount       ; /**< Tx frame count         */
    uint16_t txAbortedFrameCount; /**< Tx aborted frame count */
    uint16_t txFifoUnderrunCount; /**< Tx FIFO underrun count */
    uint32_t rxByteCount        ; /**< Rx byte count          */
    uint32_t rxFrameCount       ; /**< Rx frame count         */
    uint16_t rxAbortedFrameCount; /**< Rx aborted frame count */
}
t_Pm5384StatCounters;


void PM5384_RetrievePhyStatCounters(uint32_t                baseAddr,
                                    uint8_t                 phyId,
                                    t_Pm5384StatCounters    *p_Pm5384StatCounters);


#endif /* __PM5384_EXT_H */
