/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
/**************************************************************************//**
 @File          sdhc_std_ext.h

 @Description   SDHC common definitions
*//***************************************************************************/
#ifndef __SDHC_STD_EXT_H
#define __SDHC_STD_EXT_H


/**************************************************************************//**
 @Description   Defines the transfer mode
*//***************************************************************************/
typedef enum e_SdhcTransferMode
{
    e_SDHC_TRANS_MODE_INTERNAL_DMA,    /**< Internal DMA transfer     */
    e_SDHC_TRANS_MODE_CPU              /**< CPU transfer              */
} e_SdhcTransferMode;


/**************************************************************************//**
 @Description   Defines the data bus width to be used for data transfer.
*//***************************************************************************/
typedef enum e_SdhcBusWidth
{
    e_SDHC_BUS_WIDTH_1BIT = 1,            /**< 1-bit bus width        */
    e_SDHC_BUS_WIDTH_4BIT = 4,            /**< 4-bit bus width        */
    e_SDHC_BUS_WIDTH_8BIT = 8             /**< 8-bit bus width        */
} e_SdhcBusWidth;


/**************************************************************************//**
 @Description   Defines the abort types
*//***************************************************************************/
typedef enum e_SdhcAbortType
{
    e_SDHC_ASYNCHRONOUS_ABORT,            /**< Asynchronous abort     */
    e_SDHC_SYNCHRONOUS_ABORT              /**< Synchronous abort      */
} e_SdhcAbortType;

/**************************************************************************//**
 @Description   memory card types
*//***************************************************************************/
typedef enum e_SdhcCardType{
    e_SDHC_MMC_CARD = 0,
    e_SDHC_SD_CARD,
    e_SDHC_SDIO_CARD,
    e_SDHC_SDCOMBO_CARD,
    e_SDHC_HS_MMC_CARD,
    e_SDHC_HS_SD_CARD,
    e_SDHC_HS_SDIO_CARD,
    e_SDHC_HS_SDCOMBO_CARD,
    e_SDHC_CE_ATA_CARD,
    e_SDHC_UNKNOWN_CARD
} e_SdhcCardType;


#endif /* __SDHC_STD_EXT_H */
