/******************************************************************************

  1995-2003, 2004, 2005-2010 Freescale Semiconductor, Inc.
 All rights reserved.

 This is proprietary source code of Freescale Semiconductor Inc.,
 and its use is subject to the NetComm Device Drivers EULA.
 The copyright notice above does not evidence any actual or intended
 publication of such source code.

 **************************************************************************/
 /**************************************************************************//**
 @File          types_dflt.h

 @Description   General types Standard Definitions
*//***************************************************************************/

#ifndef __TYPES_DFLT_H
#define __TYPES_DFLT_H


#ifdef __GNUC__
/* __inline__ is already valid in GNUC */
#define _Packed
#if defined(NCSW_VXWORKS)
#define _PackedType
#else
#define _PackedType __attribute__ ((packed))
#endif  /* NCSW_VXWORKS */
#else   /* ! __GNUC__ */
#define _PackedType
#endif


#ifdef _DIAB_TOOL
#define _Packed __packed__
#define __asm__ asm
#define __volatile__ volatile
#endif



#ifdef __MWERKS__
#define __inline__ inline
#define _Packed
#define _PackedType
#endif

#ifdef _ENTERPRISE_C_
#define __packed__ __PACK__
#define _Packed __PACK__
#define _PackedType
#define __inline__
#endif

/* type definitions */
#if defined(__MWERKS__)
#include <size_t.h>
#endif /* defined (__MWERKS__) */

#if defined(NCSW_VXWORKS)
#define NETCOMMSW_ALIASING
#endif /* NCSW_VXWORKS */

#ifdef NETCOMMSW_ALIASING
#define uint8_t        _NETCOMMSW_UINT8_T_
#define uint16_t       _NETCOMMSW_UINT16_T_
#define uint32_t       _NETCOMMSW_UINT32_T_
#define uint64_t       _NETCOMMSW_UINT64_T_
#define int8_t         _NETCOMMSW_INT8_T_
#define int16_t        _NETCOMMSW_INT16_T_
#define int32_t        _NETCOMMSW_INT32_T_
#define int64_t        _NETCOMMSW_INT64_T_
#define float_t        _NETCOMMSW_FLOAT_T_
#define double_t       _NETCOMMSW_DOUBLE_T_
#define bool           _NETCOMMSW_BOOL_
#endif /* NETCOMMSW_ALIASING */

typedef unsigned char       uint8_t;    /* Unsigned  8 bit                  */
typedef unsigned short      uint16_t;   /* Unsigned 16 bit                  */
typedef unsigned long       uint32_t;   /* Unsigned 32 bit                  */
typedef signed char         int8_t;     /* Signed  8 bit                    */
typedef signed short        int16_t;    /* Signed 16 bit                    */
typedef signed long         int32_t;    /* Signed 32 bit                    */
typedef float               float_t;    /* Single precision floating point  */
typedef double              double_t;   /* Double precision floating point  */
#if (defined(__GNUC__) || defined(__MWERKS__) || defined(_DIAB_TOOL))
typedef unsigned long long  uint64_t;   /* Unsigned 64 bit                  */
typedef signed   long long  int64_t;    /* Signed 64 bit                    */
#endif /* (defined(__GNUC__) || ... */

typedef uint64_t            physAddress_t;


#define UINT8_MAX   0xFF
#define UINT8_MIN   0
#define UINT16_MAX  0xFFFF
#define UINT16_MIN  0
#define UINT32_MAX  0xFFFFFFFF
#define UINT32_MIN  0
#define UINT64_MAX  0xFFFFFFFFFFFFFFFFLL
#define UINT64_MIN  0
#define INT8_MAX    0x7F
#define INT8_MIN    0x80
#define INT16_MAX   0x7FFF
#define INT16_MIN   0x8000
#define INT32_MAX   0x7FFFFFFF
#define INT32_MIN   0x80000000
#define INT64_MAX   0x7FFFFFFFFFFFFFFFLL
#define INT64_MIN   0x8000000000000000LL


#if (defined(__cplusplus))
#undef FALSE
#undef TRUE
#define FALSE   false
#define TRUE    true
/* bool is already defined */

#else
#undef FALSE
#undef TRUE
#define FALSE   0
#define TRUE    1
typedef char bool;
#endif /* defined(__cplusplus) */


#ifndef NULL
#define NULL ((0L))
#endif /* NULL */


/************************/
/* Memory access macros */
/************************/

#define GET_UINT32(arg)             *(volatile uint32_t*)(&(arg))
#define GET_UINT64(arg)             *(volatile uint64_t*)(&(arg))

#define _WRITE_UINT32(arg, data)    *(volatile uint32_t*)(&(arg)) = (data)
#define _WRITE_UINT64(arg, data)    *(volatile uint64_t*)(&(arg)) = (data)


#define GET_UINT8(arg)              *(volatile uint8_t *)(&(arg))
#define GET_UINT16(arg)             *(volatile uint16_t*)(&(arg))

#define _WRITE_UINT8(arg, data)     *(volatile uint8_t *)(&(arg)) = (data)
#define _WRITE_UINT16(arg, data)    *(volatile uint16_t*)(&(arg)) = (data)




#define WRITE_UINT8                 _WRITE_UINT8
#define WRITE_UINT16                _WRITE_UINT16
#define WRITE_UINT32                _WRITE_UINT32
#define WRITE_UINT64                _WRITE_UINT64



#endif /* __TYPES_DFLT_H */
