/*
 * $QNXLicenseC:
 * Copyright 2007, QNX Software Systems. All Rights Reserved.
 * 
 * You must obtain a written license from and pay applicable license fees to QNX 
 * Software Systems before you may reproduce, modify or distribute this software, 
 * or any work that includes all or part of this software.   Free development 
 * licenses are available for evaluation and non-commercial purposes.  For more 
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *  
 * This file may contain contributions from others.  Please review this entire 
 * file for other proprietary rights or license notices, as well as the QNX 
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/ 
 * for other information.
 * $
 */

#include <inttypes.h>
#include <string.h>
#include <stdarg.h>
#include <alloca.h>
#include <hw/sysinfo.h>
#include <drvr/hwinfo.h>

/*******************************************************************************
* hwi_find_num_units
* 
* Given that multiple instances of a device or bus may exist in the hwinfo
* section of the sypage, determine how instances of item <name> there are.
* 
* Returns: the number of instances or -1 on error
*  
*/
int hwi_find_num_units(const char *name)
{
	int unit_cnt = -1;
	if (name != NULL)
	{	
		while (hwi_find(name, ++unit_cnt, HWI_NULL_OFF) != HWI_NULL_OFF)
		{}
		return unit_cnt;
	}
	return -1;
}

__SRCVERSION("$URL$ $Rev$");
