/*
 * $QNXLicenseC:
 * Copyright 2007, QNX Software Systems. All Rights Reserved.
 * 
 * You must obtain a written license from and pay applicable license fees to QNX 
 * Software Systems before you may reproduce, modify or distribute this software, 
 * or any work that includes all or part of this software.   Free development 
 * licenses are available for evaluation and non-commercial purposes.  For more 
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *  
 * This file may contain contributions from others.  Please review this entire 
 * file for other proprietary rights or license notices, as well as the QNX 
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/ 
 * for other information.
 * $
 */





#include <stdio.h>
#include <sys/mman.h>
#include <ioctl.h>
#include <inttypes.h>
#include <errno.h>
#include <unistd.h>
#include <drvr/support.h>

void	*mmap_typed_device_memory (void *addr, size_t len, int prot, int flags, uint64_t physical,
									char *name, int oflag, int tflag)

{
int			shm_fd;
void		*tmp;
uint32_t	offset = 0;

	if (name == NULL) {
		return (mmap_device_memory (addr, len, prot, flags, physical));
		}

	if ((shm_fd = shm_open (name, oflag, 0777)) == -1) {
		return (MAP_FAILED);
		}
	offset = (physical & 0xfff);
	tmp = mmap64 (addr, len, prot, flags, shm_fd, offset);
	close (shm_fd);
	return (tmp);
}

uintptr_t	mmap_typed_device_io (size_t len, uint64_t io, char *name, int oflag, int tflag)

{
int			shm_fd;
uintptr_t	tmp;
uint32_t	offset = 0;

	if (name == NULL) {
		if (io > 0xffff ) {
			return (uintptr_t)mmap64(0, len, PROT_NOCACHE|PROT_READ|PROT_WRITE, MAP_SHARED|MAP_PHYS, NOFD, io);
			}

		return (mmap_device_io (len, io));
		}
	
	if ((shm_fd = shm_open (name, oflag, 0777)) == -1) {
		return ((uintptr_t) MAP_FAILED);
		}
	if (len < 4096)
		len = 4096;
	offset = (io & 0xfff);
	tmp = (uintptr_t) mmap64 (0, len, PROT_NOCACHE | PROT_READ | PROT_WRITE, MAP_SHARED, shm_fd, offset);
	close (shm_fd);
	return (tmp);
}


__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/lib/drvr/memory.c $ $Rev: 580669 $" );
