/*
 * $QNXLicenseC:
 * Copyright 2007, QNX Software Systems. All Rights Reserved.
 * 
 * You must obtain a written license from and pay applicable license fees to QNX 
 * Software Systems before you may reproduce, modify or distribute this software, 
 * or any work that includes all or part of this software.   Free development 
 * licenses are available for evaluation and non-commercial purposes.  For more 
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *  
 * This file may contain contributions from others.  Please review this entire 
 * file for other proprietary rights or license notices, as well as the QNX 
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/ 
 * for other information.
 * $
 */




/*
** File: f3s_path_first.c
**
** Description:
**
** This file contains the path first function for the f3s resource manager
** for Neutrino
**
** Ident: $Id: path_first.c 580669 2011-09-01 15:18:50Z builder@qnx.com $
**
*/

/*
** Includes
*/

#include "f3s.h"

/*
** Function: f3s_path_first
*/

int32_t
f3s_path_first (char * path,
				int16_t * length)
{
	int32_t last = 1;

	/* initialize length */

	*length = 1;

	/* while path does not point to zero */

	while (*path != 0) {

		/* check if path points to directory separator */

		if (*path == '/') {

			/* clear last flag */

			last = 0;

			/* break of loop */

			break;
		}

		/* increment path pointer */

		path++;

		/* increment length */

		(*length)++;
	}

	/* return element is last flag */

	return last;
}

/*
** End
*/

__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/lib/fs-flash3/path_first.c $ $Rev: 580669 $" );
