/*
 * $QNXLicenseC:
 * Copyright 2007, QNX Software Systems. All Rights Reserved.
 * 
 * You must obtain a written license from and pay applicable license fees to QNX 
 * Software Systems before you may reproduce, modify or distribute this software, 
 * or any work that includes all or part of this software.   Free development 
 * licenses are available for evaluation and non-commercial purposes.  For more 
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *  
 * This file may contain contributions from others.  Please review this entire 
 * file for other proprietary rights or license notices, as well as the QNX 
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/ 
 * for other information.
 * $
 */




/*
** File: f3s_path_last.c
**
** Description:
**
** This file contains the path last function for the f3s resource manager
** for Neutrino
**
** Ident: $Id: path_last.c 580669 2011-09-01 15:18:50Z builder@qnx.com $
**
*/

/*
** Includes
*/

#include "f3s.h"

/*
** Function: f3s_path_last
*/

char*
f3s_path_last (char * path,
			   int16_t * length)
{
	int32_t end;

	/* find end of path loop */

	while (1) {

		/* extract base element of path */

		end = f3s_path_first (path, length);

		/* check if end of path was reached */

		if (end) {

			/* break of loop */

			break;
		}

		/* go to next element of path */

		path += *length;
	}

	/* return path pointer */

	return path;
}

/*
** End
*/

__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/lib/fs-flash3/path_last.c $ $Rev: 580669 $" );
