/*
 * $QNXLicenseC:
 * Copyright 2007, QNX Software Systems. All Rights Reserved.
 * 
 * You must obtain a written license from and pay applicable license fees to QNX 
 * Software Systems before you may reproduce, modify or distribute this software, 
 * or any work that includes all or part of this software.   Free development 
 * licenses are available for evaluation and non-commercial purposes.  For more 
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *  
 * This file may contain contributions from others.  Please review this entire 
 * file for other proprietary rights or license notices, as well as the QNX 
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/ 
 * for other information.
 * $
 */




/*
** File: f3s_swap.c
**
** Ident: $Id: swap.c 580669 2011-09-01 15:18:50Z builder@qnx.com $
*/

#include "f3s.h"

void
f3s_extptr_swap (f3s_extptr_t * swstruc)
{

	ENDIAN_SWAP16 (&swstruc->logi_unit);
	ENDIAN_SWAP16 (&swstruc->index);
}

void
f3s_stat_swap (f3s_stat_t * swstruc)
{

	ENDIAN_SWAP16 (&swstruc->struct_size);
	ENDIAN_SWAP16 (&swstruc->mode);
	ENDIAN_SWAP32 (&swstruc->uid);
	ENDIAN_SWAP32 (&swstruc->gid);
	ENDIAN_SWAP32 (&swstruc->mtime);
	ENDIAN_SWAP32 (&swstruc->ctime);
}

void
f3s_dirent_swap (f3s_dirent_t * swstruc)
{

	ENDIAN_SWAP16 (&swstruc->struct_size);
	f3s_extptr_swap (&swstruc->first);
}

void
f3s_head_swap (f3s_head_t * swstruc)
{

	ENDIAN_SWAP32 (&swstruc->status[0]);
	ENDIAN_SWAP32 (&swstruc->status[1]);
	ENDIAN_SWAP32 (&swstruc->status[2]);
	ENDIAN_SWAP16 (&swstruc->text_size);
	ENDIAN_SWAP16 (&swstruc->text_offset_lo);
	f3s_extptr_swap (&swstruc->next);
	f3s_extptr_swap (&swstruc->super);
}

void
f3s_unit_info_swap (f3s_unit_info_t * swstruc)
{

	ENDIAN_SWAP16 (&swstruc->struct_size);
	ENDIAN_SWAP16 (&swstruc->unit_pow2);
	ENDIAN_SWAP32 (&swstruc->erase_count);
	f3s_extptr_swap (&swstruc->boot);
}

void
f3s_unit_logi_swap (f3s_unit_logi_t * swstruc)
{

	ENDIAN_SWAP16 (&swstruc->struct_size);
	ENDIAN_SWAP16 (&swstruc->logi);
	ENDIAN_SWAP32 (&swstruc->age);
	ENDIAN_SWAP32 (&swstruc->md5[0]);
	ENDIAN_SWAP32 (&swstruc->md5[1]);
	ENDIAN_SWAP32 (&swstruc->md5[2]);
	ENDIAN_SWAP32 (&swstruc->md5[3]);
}

void
f3s_boot_swap (f3s_boot_t * swstruc)
{

	ENDIAN_SWAP16 (&swstruc->struct_size);
	ENDIAN_SWAP16 (&swstruc->unit_index);
	ENDIAN_SWAP16 (&swstruc->unit_total);
	ENDIAN_SWAP16 (&swstruc->unit_spare);
	ENDIAN_SWAP16 (&swstruc->align_pow2);
	f3s_extptr_swap (&swstruc->root);
}

/*
** End
*/

__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/lib/fs-flash3/swap.c $ $Rev: 580669 $" );
