/*
 * $QNXLicenseC:
 * Copyright 2007, QNX Software Systems. All Rights Reserved.
 * 
 * You must obtain a written license from and pay applicable license fees to QNX 
 * Software Systems before you may reproduce, modify or distribute this software, 
 * or any work that includes all or part of this software.   Free development 
 * licenses are available for evaluation and non-commercial purposes.  For more 
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *  
 * This file may contain contributions from others.  Please review this entire 
 * file for other proprietary rights or license notices, as well as the QNX 
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/ 
 * for other information.
 * $
 */




#ifndef __PROTO_H_INCLUDED
#define __PROTO_H_INCLUDED

struct _i2c_dev;
struct _i2c_ocb;
#define IOFUNC_ATTR_T   struct _i2c_dev
#define IOFUNC_OCB_T    struct _i2c_ocb
#include <sys/iofunc.h>
#include <sys/dispatch.h>
#include <hw/i2c.h>
#include <string.h>
#include <sys/hwinfo.h>
#include <drvr/hwinfo.h>
#include <assert.h>



typedef struct _i2c_dev {
    iofunc_attr_t       hdr;
    dispatch_t          *dpp;
    resmgr_context_t    *ctp;
    int                 id;
    i2c_master_funcs_t  mfuncs;

    void                *buf;
    unsigned            buflen;
    unsigned            bus_speed;

    void                *hdl;
	uint32_t			pid, tid;
} i2c_dev_t;

typedef struct _i2c_ocb {
    iofunc_ocb_t        hdr;
    i2c_addr_t          slave;
    unsigned            bus_speed;
} i2c_ocb_t;

typedef struct _i2c_options {
    int                 unit;
    int	            controller_num;
    unsigned            msg_max_size;
    unsigned            nparts_max;
    unsigned            default_bus_speed;
} i2c_options_t;

int _i2c_initlib(i2c_dev_t *dev);
int _i2c_options(i2c_options_t *options, int argc, char *argv[]);
int _i2c_devctl(resmgr_context_t *ctp, io_devctl_t *msg, i2c_ocb_t *ocb);
int _i2c_master_send(resmgr_context_t *ctp, io_devctl_t *msg, i2c_ocb_t *ocb);
int _i2c_master_recv(resmgr_context_t *ctp, io_devctl_t *msg, i2c_ocb_t *ocb);
int _i2c_master_sendrecv(resmgr_context_t *ctp, io_devctl_t *msg,
                         i2c_ocb_t *ocb);

i2c_ocb_t *_i2c_ocb_calloc(resmgr_context_t *ctp, i2c_dev_t *dev);
void _i2c_ocb_free(i2c_ocb_t *ocb);

int _i2c_slogf(const char *fmt, ...);

int _i2c_io_unblock(resmgr_context_t *ctp, io_pulse_t *msg, RESMGR_OCB_T *ocb);
int _i2c_io_unblock_connect(resmgr_context_t *ctp, io_pulse_t *msg, RESMGR_HANDLE_T *handle, void * reserved);
int _i2c_io_close(resmgr_context_t *ctp, void *rsrv, RESMGR_OCB_T *ocb);

#endif

__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/lib/i2c/master/proto.h $ $Rev: 580669 $" )
