/*
 * $QNXLicenseC:
 * Copyright 2007, QNX Software Systems. All Rights Reserved.
 * 
 * You must obtain a written license from and pay applicable license fees to QNX 
 * Software Systems before you may reproduce, modify or distribute this software, 
 * or any work that includes all or part of this software.   Free development 
 * licenses are available for evaluation and non-commercial purposes.  For more 
 * information visit http://licensing.qnx.com or email licensing@qnx.com.
 *  
 * This file may contain contributions from others.  Please review this entire 
 * file for other proprietary rights or license notices, as well as the QNX 
 * Development Suite License Guide at http://licensing.qnx.com/license-guide/ 
 * for other information.
 * $
 */




#include <fcntl.h>
#include <errno.h>
#include <hw/spi-master.h>

/*
 * Get driver information.
 */

int spi_getdrvinfo(int fd, spi_drvinfo_t *drvinfo)
{
	io_devctl_t	msg;
	iov_t		iov[3];
	int			status;

	/*
	 * Configurations are device specific
	 */
	if (drvinfo != NULL) {
		/* Stuff the message. */
		msg.i.type        = _IO_DEVCTL;
		msg.i.combine_len = sizeof msg.i;
		msg.i.dcmd        = DCMD_SPI_GET_DRVINFO;
		msg.i.nbytes      = sizeof(spi_drvinfo_t) + sizeof msg.i;
		msg.i.zero        = 0;

		/* Setup data to the device. */
		SETIOV(iov + 0, &msg.i, sizeof(msg.i));

		/* Setup data from the device. */
		SETIOV(iov + 1, &msg.o, sizeof(msg.o));
		SETIOV(iov + 2, drvinfo, sizeof(spi_drvinfo_t));

		if ((status = MsgSendv_r(fd, iov + 0, 1, iov + 1, 2)) != EOK)
			return (status == -ENOSYS ? ENOTTY : -status);

		return (EOK);
	}

	return (EINVAL);
}



__SRCVERSION( "$URL: http://svn/product/tags/restricted/bsp/nto650/freescale-p4080-ds/latest/src/lib/spi-master/spi_getdrvinfo.c $ $Rev: 580669 $" );
